#ifndef NT_LINK_SPEED_H_
#define NT_LINK_SPEED_H_

#include <stdint.h>

/**
 * Link speed.
 * Note this is a bitmask.
 */
enum NtLinkSpeed_e {
  NT_LINK_SPEED_UNKNOWN = 0,
  NT_LINK_SPEED_10M  = 0x01, //!< 10 Mbps
  NT_LINK_SPEED_100M = 0x02, //!< 100 Mbps
  NT_LINK_SPEED_1G   = 0x04, //!< 1 Gbps  (Autoneg only)
  NT_LINK_SPEED_10G  = 0x08, //!< 10 Gbps (Autoneg only)
  NT_LINK_SPEED_40G  = 0x10, //!< 40 Gbps (Autoneg only)
  NT_LINK_SPEED_100G = 0x20, //!< 100 Gbps (Autoneg only)
  NT_LINK_SPEED_50G  = 0x40, //!< 50 Gbps (Autoneg only)
  NT_LINK_SPEED_25G  = 0x80, //!< 25 Gbps (Autoneg only)
  NT_LINK_SPEED_END //!< always keep this entry as the last in enum
};
typedef enum NtLinkSpeed_e NtLinkSpeed_t;

const char* NT_TranslateLinkSpeed(NtLinkSpeed_t LinkSpeed);
const char* NT_TranslateLinkSpeedMask(uint32_t linkSpeedMask, char *buffer, uint32_t length);
uint64_t NT_GetLinkSpeed(NtLinkSpeed_t eLinkSpeed);

#endif // NT_LINK_SPEED_H_
