//
// nthw_fpga.h
//

/*
 * %NT_SOFTWARE_LICENSE%
 */


#ifndef __NTHW_FPGA_H__
#define __NTHW_FPGA_H__

//
#include "nthw_drv.h"
//
#include "nthw_fpga_model.h"
//
#include "nthw_rac.h"
#include "nthw_iic.h"
//
#include "nthw_si5338.h"
#include "nthw_stat.h"
//
#include "nthw_fpga_rst.h"
//
#include "nthw_fpga_nt200a0x.h"
#include "nthw_fpga_nt50b0x.h"
//
#include "nthw_dbs.h"
//
#include "nthw_mcu.h"
//
// Defines:
//

//
//
//

//
// Functions:
//
int NthwFpga_init(struct FpgaInfo_s* pFpgaInfo);
int NthwFpga_shutdown(struct FpgaInfo_s* pFpgaInfo);

//
int NthwFpga_get_param_info(struct FpgaInfo_s* pFpgaInfo, Fpga_t* pFpga);
//
int NthwFpga_avr_probe(Fpga_t* pFpga, const int nInstanceNo);
//
int NthwFpga_iic_scan(Fpga_t* pFpga, const int nInstanceNoBegin, const int nInstanceNoEnd);
//
int NthwFpga_iic_read_byte(Fpga_t* pFpga, const int nInstanceNo, const uint8_t nDevAddr, const uint8_t nRegAddr);
int NthwFpga_iic_write_byte(Fpga_t* pFpga, const int nInstanceNo, const uint8_t nDevAddr, const uint8_t nRegAddr, uint8_t val);
//
int NthwFpga_silabs_detect(Fpga_t* pFpga, const int nInstanceNo, const int nDevAddr, const int nPageRegAddr);
//
int NthwFpga_si5338_clock_synth_init_Fmt0(Fpga_t* pFpga, const uint8_t nIicAddr, const clkProfileDataFmt0_t* pClkProfile, const int nClkProfileRecCnt);
int NthwFpga_si5340_clock_synth_init_Fmt1(Fpga_t* pFpga, const uint8_t nIicAddr, const clkProfileDataFmt1_t* pClkProfile, const int nClkProfileRecCnt);
int NthwFpga_si5340_clock_synth_init_Fmt2(Fpga_t* pFpga, const uint8_t nIicAddr, const clkProfileDataFmt2_t* pClkProfile, const int nClkProfileRecCnt);

//
//
//
#endif // __NTHW_FPGA_H__

//
// EOF
//
