//
// nthw_fpga_rst_nt200a0x.h
//


#ifndef __NTHW_FPGA_RST_NT200A0X_H__
#define __NTHW_FPGA_RST_NT200A0X_H__

//
#include "nthw_drv.h"
//
#include "nthw_fpga_model.h"
//

//
// Defines:
//

//
// Structs:
//
struct NthwFpga_rst_nt200a0x
{
  //
  int mnFpgaProductId;
  int mnFpgaVersion;
  int mnFpgaRevision;
  //
  int mnHwId;
  //bool mbIsNT200A01;
  //
  int mnSiLabsClockSynthModel;
  uint8_t mnSiLabsClockSynthI2cAddr;
  //
  Field_t* mpFldRstSys;
  Field_t* mpFldRstSysMmcm;
  Field_t* mpFldRstCoreMmcm;
  Field_t* mpFldRstRpp;
  Field_t* mpFldRstDdr4;
  Field_t* mpFldRstSdc;
  Field_t* mpFldRstPhy;
  Field_t* mpFldRstSerdesRx;
  Field_t* mpFldRstSerdesTx;
  Field_t* mpFldRstSerdesRxDatapath;
  Field_t* mpFldRstPcsRx;
  Field_t* mpFldRstMacRx;
  Field_t* mpFldRstMacTx;
  Field_t* mpFldRstPtp;
  Field_t* mpFldRstTs;
  Field_t* mpFldRstPtpMmcm;
  Field_t* mpFldRstTsMmcm;
  Field_t* mpFldRstPeriph;
  Field_t* mpFldRstTsmRefMmcm;
  Field_t* mpFldRstTmc;

  // CTRL register field pointers
  Field_t* mpFldCtrlTsClkSelOverride;
  Field_t* mpFldCtrlTsClkSel;
  Field_t* mpFldCtrlTsClkSelRef;
  Field_t* mpFldCtrlPtpMmcmClkSel;

  // STAT register field pointers
  Field_t* mpFldStatDdr4MmcmLocked;
  Field_t* mpFldStatSysMmcmLocked;
  Field_t* mpFldStatCoreMmcmLocked;
  Field_t* mpFldStatDdr4PllLocked;
  Field_t* mpFldStatPtpMmcmLocked;
  Field_t* mpFldStatTsMmcmLocked;
  Field_t* mpFldStatTsmRefMmcmLocked;

  // STICKY register field pointers
  Field_t* mpFldStickyPtpMmcmUnlocked;
  Field_t* mpFldStickyTsMmcmUnlocked;
  Field_t* mpFldStickyDdr4MmcmUnlocked;
  Field_t* mpFldStickyDdr4PllUnlocked;
  Field_t* mpFldStickyCoreMmcmUnlocked;
  Field_t* mpFldStickyPciSysMmcmUnlocked;
  Field_t* mpFldStickyTsmRefMmcmUnlocked;

  // POWER register field pointers
  Field_t* mpFldPowerPuPhy;
  Field_t* mpFldPowerPuNseb;
  //

  void (*resetSerdesRx)(struct NthwFpga_rst_nt200a0x *p, uint32_t intfNo, uint32_t rst);
  void (*pcs_rx_rst)(struct NthwFpga_rst_nt200a0x *p, uint32_t intfNo, uint32_t rst);
  void (*get_serdes_rx_rst)(struct NthwFpga_rst_nt200a0x *p, uint32_t intfNo, uint32_t *pSet);
  void (*get_pcs_rx_rst)(struct NthwFpga_rst_nt200a0x *p, uint32_t intfNo, uint32_t *pSet);
  bool (*is_rst_serdes_rx_datapath_implemented)(struct NthwFpga_rst_nt200a0x *p);
};

typedef struct NthwFpga_rst_nt200a0x NthwFpga_rst_nt200a0x_t;

//
// Funcs:
//
int NthwFpga_rst_nt200a0x_init(struct FpgaInfo_s* pFpgaInfo, struct NthwFpga_rst_nt200a0x* pRst);
int NthwFpga_rst_nt200a0x_reset(Fpga_t* pFpga, const struct NthwFpga_rst_nt200a0x* p);


//
//
//
#endif // __NTHW_FPGA_RST_NT200A0X_H__

//
// EOF
//
