//
// nthw_fpga_rst_nt50b0x.h
//


#ifndef __NTHW_FPGA_RST_NT50B0X_H__
#define __NTHW_FPGA_RST_NT50B0X_H__

//
#include "nthw_drv.h"
//
#include "nthw_fpga_model.h"
//
#include "nthw_rac.h"
#include "nthw_iic.h"
//

//
// Defines:
//

//
// Structs:
//
struct NthwFpga_rst_nt50b0x
{
  Fpga_t* mpFpga;
  //
  int mnFpgaProductId;
  int mnFpgaVersion;
  int mnFpgaRevision;
  //
  int mnHwId;
  //
  int mnSiLabsClockSynthModel;
  uint8_t mnSiLabsClockSynthI2cAddr;
  //
  Module_t* mpModRst;
  int mnInstance;
  //
  // PRM/PCM:
  Module_t* mpModPrm;
  Module_t* mpModPcm;
  //
  Field_t* mpFldRstSys;
  Field_t* mpFldRstSysMmcm;
  Field_t* mpFldRstCoreMmcm;
  Field_t* mpFldRstRpp;
  Field_t* mpFldRstDdr4;
  Field_t* mpFldRstSdc;
  Field_t* mpFldRstPhy;
  Field_t* mpFldRstSerdesRx;
  Field_t* mpFldRstSerdesTx;
  Field_t* mpFldRstSerdesRxDatapath;
  Field_t* mpFldRstPcsRx;
  Field_t* mpFldRstMacRx;
  Field_t* mpFldRstMacTx;
  Field_t* mpFldRstPtp;
  Field_t* mpFldRstTs;
  Field_t* mpFldRstPtpMmcm;
  Field_t* mpFldRstTsMmcm;
  Field_t* mpFldRstPeriph;
  Field_t* mpFldRstTsmRefMmcm;
  Field_t* mpFldRstTmc;

  // CTRL register field pointers
  Field_t* mpFldCtrlTsClkSelOverride;
  Field_t* mpFldCtrlTsClkSel;
  Field_t* mpFldCtrlTsClkSelRef;
  Field_t* mpFldCtrlPtpMmcmClkSel;

  // STAT register field pointers
  Field_t* mpFldStatDdr4MmcmLocked;
  Field_t* mpFldStatSysMmcmLocked;
  Field_t* mpFldStatCoreMmcmLocked;
  Field_t* mpFldStatDdr4PllLocked;
  Field_t* mpFldStatPtpMmcmLocked;
  Field_t* mpFldStatTsMmcmLocked;
  Field_t* mpFldStatTsmRefMmcmLocked;
  //STAT register field pointers nt50b0x
  Field_t* mpFldStatDdr4CalibComplete;

  //LATCH register field pointers
  Field_t* mpFldLatchDdr4CalibComplete;

  // STICKY register field pointers
  Field_t* mpFldStickyPtpMmcmUnlocked;
  Field_t* mpFldStickyTsMmcmUnlocked;
  Field_t* mpFldStickyDdr4MmcmUnlocked;
  Field_t* mpFldStickyDdr4PllUnlocked;
  Field_t* mpFldStickyCoreMmcmUnlocked;
  Field_t* mpFldStickyPciSysMmcmUnlocked;
  Field_t* mpFldStickyTsmRefMmcmUnlocked;

  // POWER register field pointers
  Field_t* mpFldPowerPuPhy;
  Field_t* mpFldPowerPuNseb;
  //

  // RST extra fields
  Field_t* mpFldStatPhyRdy;
  Field_t* mpFldLatchPhyRdy;

  // PRM extra fields
  Field_t* mpFldRstPlatform; // PRM

  // PCM extra fields
  Field_t* mpFldCtrlTsMmcmRst; // PCM
  Field_t* mpFldLatchTsMmcmLocked; // PCM
};

//
// Funcs:
//
int NthwFpga_rst_nt50b0x_init(struct FpgaInfo_s* pFpgaInfo, struct NthwFpga_rst_nt50b0x* pRst);
int NthwFpga_rst_nt50b0x_reset(Fpga_t* pFpga, const struct NthwFpga_rst_nt50b0x* p);
//
int NthwFpga_rst_nt50b0x_wait_sdc_calibrated(Fpga_t* pFpga, const struct NthwFpga_rst_nt50b0x* p);
int NthwFpga_rst_nt50b0x_wait_ddr4_calibration_complete(Fpga_t* pFpga, const struct NthwFpga_rst_nt50b0x* p);
//
int NthwFpga_rst_nt50b0x_2X25_resetPhyMac(Fpga_t* pFpga, const struct NthwFpga_rst_nt50b0x* p);


//
//
//
#endif // __NTHW_FPGA_RST_NT50B0X_H__

//
// EOF
//
