//
// nthw_gpio_sfpp.h
//

/*
 * %NT_SOFTWARE_LICENSE%
 */


#ifndef NTHW_GPIO_SFPP_H_
#define NTHW_GPIO_SFPP_H_

//
//
//

struct NthwGpioSfpp
{
  Fpga_t* mpFpga;
  Module_t* mpModGpioSfpp;
  int mnInstance;
  //

  //
  Register_t* mpGpioSfppCfg;
  Field_t* mpGpioSfppCfgAbs;
  Field_t* mpGpioSfppCfgRxlos;
  Field_t* mpGpioSfppCfgTxfault;
  Field_t* mpGpioSfppCfgTxdisable;
  Field_t* mpGpioSfppCfgRs;
  //
  Register_t* mpGpioSfppGpio;
  Field_t* mpGpioSfppGpioAbs;
  Field_t* mpGpioSfppGpioRxlos;
  Field_t* mpGpioSfppGpioTxfault;
  Field_t* mpGpioSfppGpioTxdisable;
  Field_t* mpGpioSfppGpioRs;
};

typedef struct NthwGpioSfpp NthwGpioSfpp_t;
typedef struct NthwGpioSfpp NthwGpioSfpp;

//
//
//
NthwGpioSfpp_t* NthwGpioSfpp_new(void);
void NthwGpioSfpp_delete(NthwGpioSfpp_t* p);
int NthwGpioSfpp_init(NthwGpioSfpp_t* p, Fpga_t* pFpga, int nInstance);
//
bool NthwGpioSfpp_isSfppPresent(NthwGpioSfpp_t* p);
bool NthwGpioSfpp_isRxLos(NthwGpioSfpp_t* p);
void NthwGpioSfpp_setTxFault(NthwGpioSfpp_t* p, bool fault);
void NthwGpioSfpp_setTxDisable(NthwGpioSfpp_t* p, bool disable);
void NthwGpioSfpp_setRs(NthwGpioSfpp_t* p, uint8_t rs);

//
//
//
#endif // NTHW_GPIO_SFPP_H_

//
// EOF
//
