//
// nthw_hif.h
//

/*
 * %NT_SOFTWARE_LICENSE%
 */


#ifndef __NTHW_HIF_H__
#define __NTHW_HIF_H__

//
// Defines:
//
#define NTHW_TG_CNT_SIZE (4ULL)

//
//
//
struct NthwHif
{
  Fpga_t* mpFpga;
  //
  Module_t* mpModHif;
  //
  int mnInstance;
  //
  //
  Register_t* mpRegProdIdLsb;
  Field_t* mpFldProdIdLsbRevId;
  Field_t* mpFldProdIdLsbVerId;
  Field_t* mpFldProdIdLsbGroupId;
  //
  Register_t* mpRegProdIdMsb;
  Field_t* mpFldProdIdMsbTypeId;
  Field_t* mpFldProdIdMsbBuildNo;
  //
  Register_t* mpRegBuildTime;
  Field_t* mpFldBuildTime;
  //
  Register_t* mpRegBuildSeed;
  Field_t* mpFldBuildSeed;
  //
  Register_t* mpRegCoreSpeed;
  Field_t* mpFldCoreSpeed;
  Field_t* mpFldDdr3Speed;
  //
  Register_t* mpRegIntMask;
  Field_t* mpFldIntMaskTimer;
  Field_t* mpFldIntMaskPort;
  Field_t* mpFldIntMaskPps;
  //
  Register_t* mpRegIntClr;
  Field_t* mpFldIntClrTimer;
  Field_t* mpFldIntClrPort;
  Field_t* mpFldIntClrPps;
  //
  Register_t* mpRegIntForce;
  Field_t* mpFldIntForceTimer;
  Field_t* mpFldIntForcePort;
  Field_t* mpFldIntForcePps;
  //
  Register_t* mpRegSampleTime;
  Field_t* mpFldSampleTime;
  //
  Register_t* mpRegStatus;
  Field_t* mpFldStatusTagsInUse;
  Field_t* mpFldStatusWrErr;
  Field_t* mpFldStatusRdErr;
  //
  Register_t* mpRegStatCtrl;
  Field_t* mpFldStatCtrlEna;
  Field_t* mpFldStatCtrlReq;
  //
  Register_t* mpRegStatRx;
  Field_t* mpFldStatRxCounter;
  //
  Register_t* mpRegStatTx;
  Field_t* mpFldStatTxCounter;
  //
  Register_t* mpRegStatRefClk;
  Field_t* mpFldStatRefClkRefClk;
  //
  Register_t* mpRegPciTest0;
  Field_t* mpFldPciTest0;
  //
  Register_t* mpRegPciTest1;
  Field_t* mpFldPciTest1;
  //
  Register_t* mpRegPciTest2;
  Field_t* mpFldPciTest2;
  //
  Register_t* mpRegPciTest3;
  Field_t* mpFldPciTest3;
  //
  Register_t* mpRegConfig;
  Field_t* mpFldMaxTlp;
  Field_t* mpFldMaxRead;
  Field_t* mpFldExtTag;
  //
  int mnFpgaIdItem;
  int mnFpgaIdProd;
  int mnFpgaIdVer;
  int mnFpgaIdRev;
  int mnFpgaIdBuildNo;
  //
  int mnFpgaParamHifPerPs;
  uint32_t mnFpgaHifRefClkFreq;
  //

};


typedef struct NthwHif NthwHif_t;
typedef struct NthwHif NthwHif;

//
//
//
struct NthwHif_EndPointErrCounters {
  uint32_t nErrCorrectable, nErrNonFatal, nErrFatal;
};

//
//
//
struct NthwHif_EndPointCounters {
  //
  int nNumaNode;
  //
  int nTgDirection;
  int nTgPktSize;
  int nTgNumPkts;
  int nTgDelay;
  //
  uint64_t curRx, curTx;
  uint64_t curPciNtUtil, curPciXilUtil;
  uint64_t nRefClkCnt;
  //
  uint64_t nTagsInUse;
  uint64_t nRdErr;
  uint64_t nWrErr;
  //
  struct NthwHif_EndPointErrCounters sRcEpPre, sRcEpPost, sRcEpDelta;
  struct NthwHif_EndPointErrCounters sEpRcPre, sEpRcPost, sEpRcDelta;
  //
  int boError;
};


//
//
//
struct NthwHif_EndPoints {
  struct NthwHif_EndPointCounters pri, sla;
};


//
//
//
NthwHif_t* NthwHif_new(void);
void NthwHif_delete(NthwHif_t* p);
int NthwHif_init(NthwHif_t* p, Fpga_t* pFpga, int nInstance);
//
int NthwHif_setupConfig(NthwHif_t* p);
//
int NthwHif_trigger_sample_time(NthwHif_t* p);
//
int NthwHif_StatReqEnable(NthwHif_t* p);
int NthwHif_StatReqDisable(NthwHif_t* p);
int NthwHif_StatSample(NthwHif_t* p, uint64_t* pRxRate, uint64_t* pTxRate, uint64_t* pRefClkCnt, uint64_t* pTagsInUse, uint64_t* pRdErrCnt, uint64_t* pWrErrCnt);
//
int NthwHif_getStat(NthwHif_t* p, uint32_t* pRxCnt, uint32_t* pTxCnt, uint32_t* pRefClkCnt, uint32_t* pTgUnitSize, uint32_t* pTgRefFreq, uint64_t* pTagsInUse, uint64_t* pRdErr, uint64_t* pWrErr);
int NthwHif_getStatRate(NthwHif_t* p, uint64_t* pPciRxRate, uint64_t* pPciTxRate, uint64_t* pRefClkCnt, uint64_t* pTagsInUse, uint64_t* pRdErrCnt, uint64_t* pWrErrCnt);
//
int NthwHif_EndPointCountersSample(NthwHif_t* p, struct NthwHif_EndPointCounters* epc);

//
//
//
#endif // __NTHW_HIF_H__


//
// EOF
//
