//
// nthw_iic.h
//

/*
 * %NT_SOFTWARE_LICENSE%
 */

//
//
//

#ifndef __NTHW_IIC_H__
#define __NTHW_IIC_H__


#include "nthw_fpga_model.h"

//
//
//
struct NthwIic
{
  Fpga_t* mpFpga;
  //
  Module_t* mpModIic;
  //
  int mnIicInstance;
  //
  uint32_t mnIicCycleTime;
  int mnPollDelay;
  int mnBusReadyRetry;
  int mnDataReadyRetry;
  int mnReadDataRetry;
  int mnWriteDataRetry;
  //
  Register_t* mpReg_tsusta;
  Field_t* mpFld_tsusta;
  //
  Register_t* mpReg_tsusto;
  Field_t* mpFld_tsusto;
  //
  Register_t* mpReg_thdsta;
  Field_t* mpFld_thdsta;
  //
  Register_t* mpReg_tsudat;
  Field_t* mpFld_tsudat;
  //
  Register_t* mpReg_tbuf;
  Field_t* mpFld_tbuf;
  //
  Register_t* mpReg_thigh;
  Field_t* mpFld_thigh;
  //
  Register_t* mpReg_tlow;
  Field_t* mpFld_tlow;
  //
  Register_t* mpReg_thddat;
  Field_t* mpFld_thddat;
  //
  Register_t* mpReg_cr;
  Field_t* mpFld_cr_en;
  Field_t* mpFld_cr_msms;
  Field_t* mpFld_cr_txfifo_reset;
  Field_t* mpFld_cr_txak;
  //
  Register_t* mpReg_sr;
  Field_t* mpFld_sr_bb;
  Field_t* mpFld_sr_rxfifo_full;
  Field_t* mpFld_sr_rxfifo_empty;
  Field_t* mpFld_sr_txfifo_full;
  Field_t* mpFld_sr_txfifo_empty;
  //
  Register_t* mpReg_tx_fifo;
  Field_t* mpFld_tx_fifo_txdata;
  Field_t* mpFld_tx_fifo_start;
  Field_t* mpFld_tx_fifo_stop;
  //
  Register_t* mpReg_rx_fifo_pirq;
  Field_t* mpFld_rx_fifo_pirq_cmp_val;
  //
  Register_t* mpReg_rx_fifo;
  Field_t* mpFld_rx_fifo_rxdata;
  //
  Register_t* mpReg_softr;
  Field_t* mpFld_softr_rkey;

};

typedef struct NthwIic NthwIic_t;
typedef struct NthwIic NthwIic;

//
//
//
NthwIic_t* NthwIic_new(void);
int NthwIic_init(NthwIic_t *p, Fpga_t *pFpga, int nIicInstance,
                 uint32_t nIicCycleTime);
void NthwIic_delete(NthwIic_t* p);
//
int NthwIic_SetRetryParams(NthwIic_t* p, const int nPollDelay, const int nBusReadyRetry, const int nDataReadyRetry, const int nReadDataRetry, const int nWriteDataRetry);
//
int NthwIic_readData(NthwIic_t* p, uint8_t DevAddr, uint8_t RegAddr, uint8_t DataLen, void* pVoid);
int NthwIic_readbyte(NthwIic_t* p, uint8_t DevAddr, uint8_t RegAddr, uint8_t DataLen, uint8_t* pByte);
int NthwIic_writeData(NthwIic_t* p, uint8_t DevAddr, uint8_t RegAddr, uint8_t DataLen, void* pVoid);
int NthwIic_writebyte(NthwIic_t* p, uint8_t DevAddr, uint8_t RegAddr, uint8_t DataLen, uint8_t* pByte);
bool NthwIic_busReady(NthwIic_t* p);
bool NthwIic_dataReady(NthwIic_t* p);
//
int NthwIic_scan(NthwIic_t* p);
int NthwIic_scan_dev_addr(NthwIic_t* p, int nDevAddr, int nRegAddr);
int NthwIic_scan_find_dev(NthwIic_t* p, int nDevAddrStart, bool bIncreate);

//
//
//
#endif // __NTHW_IIC_H__

//
// EOF
//
