//
// nthw_mac10g.h
//

/*
 * %NT_SOFTWARE_LICENSE%
 */

#ifndef NTHW_MAC10G_H_
#define NTHW_MAC10G_H_


//
//
//

struct NthwMac10g {
  //
  Fpga_t* mpFpga;
  //
  Module_t* mpModMac10g;
  //
  int mnInstance;

  // Control
  Field*    mpRxEnable;
  Field*    mpRxPauseEnable;
  Field*    mpTxEnable;
  Field*    mpTxPauseEnable;
  Field*    mpStrEnable;
  Field*    mpRxMinFrame;

  // MAC Address
  Field*    mpMacAddrLower;
  Field*    mpMacAddrUpper;

  // RX MAC Enable (RX_CONFIG)
  Field*    mpFldTsEop;
};


typedef struct NthwMac10g NthwMac10g_t;
typedef struct NthwMac10g NthwMac10g;

//
//
//
NthwMac10g_t* NthwMac10g_new(void);
void NthwMac10g_delete(NthwMac10g_t* p);
int NthwMac10g_init(NthwMac10g_t *p, Fpga_t *pFpga, int nInstance);
//
void NthwMac10g_EnableStretch(NthwMac10g_t* p, bool enable);
void NthwMac10g_setRxEnable(NthwMac10g_t* p, bool enable);
void NthwMac10g_setTxEnable(NthwMac10g_t* p, bool enable);
void NthwMac10g_setRxPauseEnable(NthwMac10g_t* p, bool enable);
void NthwMac10g_setTxPauseEnable(NthwMac10g_t* p, bool enable);
void NthwMac10g_SetMacAddr(NthwMac10g_t* p, uint8_t macAddr[6]);
void NthwMac10g_setTsEop(NthwMac10g_t* p, uint32_t bitEop);
void NthwMac10g_setRxMinFrame(NthwMac10g_t* p, uint32_t min_rx_frame);

//
//
//
#endif // NTHW_MAC10G_H_

//
// EOF
//
