//
// nthw_mac100.hpp
//

/*
 * %NT_SOFTWARE_LICENSE%
 */

#ifndef NTHW_MAC1_H_
#define NTHW_MAC1_H_


//
//
//

struct NthwMac1g {
  //
  Fpga_t* mpFpga;
  //
  Module_t* mpModMac1g;
  //
  int mnInstance;
  //

  // Control
  Field_t*    mpRxEnable;
  Field_t*    mpRxPauseEnable;
  Field_t*    mpTxEnable;
  Field_t*    mpFldTsEop;
  Field_t*    mpRxMinFrame;
  Field_t*    mpTxPauseEnable;
  Field_t*    mpStrEnable;
  Field_t*    mpSpeed;

  // MAC Address
  Field_t*    mpMacAddrLower;
  Field_t*    mpMacAddrUpper;

};

typedef struct NthwMac1g NthwMac1g_t;
typedef struct NthwMac1g NthwMac1g;

//
//
//
NthwMac1g_t* NthwMac1g_new(void);
void NthwMac1g_delete(NthwMac1g_t* p);
int NthwMac1g_init(NthwMac1g_t *p, Fpga_t *pFpga, int nInstance);
//
void NthwMac1g_EnableStretch(NthwMac1g_t* p, bool enable);
void NthwMac1g_setRxEnable(NthwMac1g_t* p, bool enable);
void NthwMac1g_setTxEnable(NthwMac1g_t* p, bool enable);
void NthwMac1g_setTsEop(NthwMac1g_t* p, uint32_t bitEop);
void NthwMac1g_setRxMinFrame(NthwMac1g_t* p, uint32_t min_rx_frame);
void NthwMac1g_setRxPauseEnable(NthwMac1g_t* p, bool enable);
void NthwMac1g_setTxPauseEnable(NthwMac1g_t* p, bool enable);
void NthwMac1g_SetMacAddr(NthwMac1g_t* p, uint8_t macAddr[6]);
void NthwMac1g_SetSpeed(NthwMac1g_t* p, uint8_t speed);

//
//
//
#endif // NTHW_MAC1_H_

//
// EOF
//
