//
// nthw_mac_pcs.hp
//

//
//
//
#ifndef NTHW_MAC_PCS_H_
#define NTHW_MAC_PCS_H_

//
//
//

enum NthwMacPcs_LEDMode_e {
  NTHW_MAC_PCS_LED_AUTO = 0x00,
  NTHW_MAC_PCS_LED_ON = 0x01,
  NTHW_MAC_PCS_LED_OFF = 0x02,
  NTHW_MAC_PCS_LED_PORTID = 0x03,
};

//
//
//

//static const uint8_t cNthwMacPcsReceiverModeDFE = 0;
//static const uint8_t cNthwMacPcsReceiverModeLPM = 1;
#define NthwMacPcs_ReceiverModeDFE (0)
#define NthwMacPcs_ReceiverModeLPM (1)


//
//
//
struct NthwMacPcs
{
  uint8_t mPortNo;

  //
  Fpga_t*     mpFpga;
  //
  Module_t*    mpModMacPcs;
  //
  int mnInstance;

  // Block lock status
  Field_t*    mpFldBlockLockLock;
  uint32_t        mFldBlockLockLockMask;

  // Lane lock status
  Field_t*    mpFldVlDemuxedLock;
  uint32_t        mFldVlDemuxedLockMask;

  // GTY_STAT
  Field_t*    mpFldGtyStatRxRstDone0;
  Field_t*    mpFldGtyStatRxRstDone1;
  Field_t*    mpFldGtyStatRxRstDone2;
  Field_t*    mpFldGtyStatRxRstDone3;
  Field_t*    mpFldGtyStatTxRstDone0;
  Field_t*    mpFldGtyStatTxRstDone1;
  Field_t*    mpFldGtyStatTxRstDone2;
  Field_t*    mpFldGtyStatTxRstDone3;
  uint32_t        mFldGtyStatRxRstDoneMask;
  uint32_t        mFldGtyStatTxRstDoneMask;

  // GTY_LOOP
  Register_t* mpRegGtyLoop;
  Field_t*    mpFldGtyLoopGtLoop0;
  Field_t*    mpFldGtyLoopGtLoop1;
  Field_t*    mpFldGtyLoopGtLoop2;
  Field_t*    mpFldGtyLoopGtLoop3;

  // MAC_PCS_CONFIG
  Field_t*    mpFldPcsConfigTxPathRst;
  Field_t*    mpFldPcsConfigRxPathRst;
  Field_t*    mpFldPcsConfigRxEnable;
  Field_t*    mpFldPcsConfigRxForceResync;
  Field_t*    mpFldPcsConfigRxTestPattern;
  Field_t*    mpFldPcsConfigTxEnable;
  Field_t*    mpFldPcsConfigTxSendIdle;
  Field_t*    mpFldPcsConfigTxSendRfi;
  Field_t*    mpFldPcsConfigTxTestPattern;

  // STAT PCS
  Field_t*    mpFldStatPcsRxStatus;
  Field_t*    mpFldStatPcsRxAligned;
  Field_t*    mpFldStatPcsRxAlignedErr;
  Field_t*    mpFldStatPcsRxMisaligned;
  Field_t*    mpFldStatPcsRxInternalLocalFault;
  Field_t*    mpFldStatPcsRxReceivedLocalFault;
  Field_t*    mpFldStatPcsRxLocalFault;
  Field_t*    mpFldStatPcsRxRemoteFault;
  Field_t*    mpFldStatPcsRxHiBer;

  // STAT_PCS_RX_LATCH
  Field_t*    mpFldStatPcsRxLatchStatus;

  // PHYMAC_MISC
  Field_t*    mpFldPhymacMiscTxSelHost;
  Field_t*    mpFldPhymacMiscTxSelTfg;
  Field_t*    mpFldPhymacMiscTxSelRxLoop;
  Field_t*    mpFldPhymacMiscTsEop;

  // LINK_SUMMARY
  Register_t* mpRegLinkSummary;
  Field_t*    mpFldLinkSummaryAbs;
  Field_t*    mpFldLinkSummaryNtPhyLinkState;
  Field_t*    mpFldLinkSummaryLhAbs;
  Field_t*    mpFldLinkSummaryLlNtPhyLinkState;
  Field_t*    mpFldLinkSummaryLinkDownCnt;
  Field_t*    mpFldLinkSummaryNimInterr;
  Field_t*    mpFldLinkSummaryLhLocalFault;
  Field_t*    mpFldLinkSummaryLhRemoteFault;
  Field_t*    mpFldLinkSummaryLocalFault;
  Field_t*    mpFldLinkSummaryRemoteFault;

  // BIP_ERR
  Register_t* mpRegBipErr;
  Field_t*    mpFldRegBipErrBipErr;

  // FEC_CTRL
  Register_t* mpRegFecCtrl;
  Field_t*    mpFieldFecCtrlRegRsFecCtrlIn;

  // FEC_STAT
  Register_t* mpRegFecStat;
  Field_t*    mpFieldFecStatBypass;
  Field_t*    mpFieldFecStatValid;
  Field_t*    mpFieldFecStatAmLock0;
  Field_t*    mpFieldFecStatAmLock1;
  Field_t*    mpFieldFecStatAmLock2;
  Field_t*    mpFieldFecStatAmLock3;
  Field_t*    mpFieldFecStatFecLaneAlgn;

  // FEC Corrected code word count
  Register_t* mpRegFecCwCnt;
  Field_t*    mpFieldFecCwCntCwCnt;

  // FEC Uncorrected code word count
  Register_t* mpRegFecUcwCnt;
  Field_t*    mpFieldFecUcwCntUcwCnt;


  // GTY_RX_BUF_STAT
  Register_t* mpRegGtyRxBufStat;
  Field_t*    mpFieldGtyRxBufStatRxBufStat0;
  Field_t*    mpFieldGtyRxBufStatRxBufStat1;
  Field_t*    mpFieldGtyRxBufStatRxBufStat2;
  Field_t*    mpFieldGtyRxBufStatRxBufStat3;
  Field_t*    mpFieldGtyRxBufStatRxBufStatChanged0;
  Field_t*    mpFieldGtyRxBufStatRxBufStatChanged1;
  Field_t*    mpFieldGtyRxBufStatRxBufStatChanged2;
  Field_t*    mpFieldGtyRxBufStatRxBufStatChanged3;

  // GTY_PRE_CURSOR
  Register_t* mpRegGtyPreCursor;
  Field_t*    mpFieldGtyPreCursorTxPreCsr0;
  Field_t*    mpFieldGtyPreCursorTxPreCsr1;
  Field_t*    mpFieldGtyPreCursorTxPreCsr2;
  Field_t*    mpFieldGtyPreCursorTxPreCsr3;

  // GTY_DIFF_CTL
  Register_t* mpRegGtyDiffCtl;
  Field_t*    mpFieldGtyGtyDiffCtlTxDiffCtl0;
  Field_t*    mpFieldGtyGtyDiffCtlTxDiffCtl1;
  Field_t*    mpFieldGtyGtyDiffCtlTxDiffCtl2;
  Field_t*    mpFieldGtyGtyDiffCtlTxDiffCtl3;

  // GTY_POST_CURSOR
  Register_t* mpRegGtyPostCursor;
  Field_t*    mpFieldGtyPostCursorTxPostCsr0;
  Field_t*    mpFieldGtyPostCursorTxPostCsr1;
  Field_t*    mpFieldGtyPostCursorTxPostCsr2;
  Field_t*    mpFieldGtyPostCursorTxPostCsr3;

  // GTY_CTL
  Register_t* mpRegGtyCtl;
  Register_t* mpRegGtyCtlTx;
  Field_t*    mpFieldGtyCtlTxPol0;
  Field_t*    mpFieldGtyCtlTxPol1;
  Field_t*    mpFieldGtyCtlTxPol2;
  Field_t*    mpFieldGtyCtlTxPol3;
  Field_t*    mpFieldGtyCtlRxPol0;
  Field_t*    mpFieldGtyCtlRxPol1;
  Field_t*    mpFieldGtyCtlRxPol2;
  Field_t*    mpFieldGtyCtlRxPol3;
  Field_t*    mpFieldGtyCtlRxLpmEn0;
  Field_t*    mpFieldGtyCtlRxLpmEn1;
  Field_t*    mpFieldGtyCtlRxLpmEn2;
  Field_t*    mpFieldGtyCtlRxLpmEn3;
  Field_t*    mpFieldGtyCtlRxEquaRst0;
  Field_t*    mpFieldGtyCtlRxEquaRst1;
  Field_t*    mpFieldGtyCtlRxEquaRst2;
  Field_t*    mpFieldGtyCtlRxEquaRst3;

  // DEBOUNCE_CTRL
  Register_t* mpRegDebounceCtrl;
  Field_t*    mpFieldDebounceCtrlNtPortCtrl;


  // TIMESTAMP_COMP
  Register_t* mpRegTimeStampComp;
  Field_t*    mpFieldTimeStampCompRxDly;
  Field_t*    mpFieldTimeStampCompTxDly;

  // STAT_PCS_RX
  Register_t *mpRegStatPcsRx;

  // STAT_PCS_RX
  Register_t *mpRegStatPcsRxLatch;

  // PHYMAC_MISC
  Register_t *mpRegPhymacMisc;

  // BLOCK_LOCK
  Register_t *mpRegBlockLock;
};

typedef struct NthwMacPcs NthwMacPcs_t;
typedef struct NthwMacPcs NthwMacPcs;

//
//
//

//
//
//
NthwMacPcs_t* NthwMacPcs_new(void);
int NthwMacPcs_init(NthwMacPcs_t *p, Fpga_t *pFpga, int nInstance);
void NthwMacPcs_delete(NthwMacPcs_t* p);
//
bool NthwMacPcs_isBlockAndLaneLockLocked(NthwMacPcs_t* p);
bool NthwMacPcs_isGtFsmRxResetDone(NthwMacPcs_t* p);
bool NthwMacPcs_isGtFsmTxResetDone(NthwMacPcs_t* p);
void NthwMacPcs_txPathRst(NthwMacPcs_t* p, bool enable);
void NthwMacPcs_rxPathRst(NthwMacPcs_t* p, bool enable);
bool NthwMacPcs_isRxPathRst(NthwMacPcs_t* p);
void NthwMacPcs_rxForceResync(NthwMacPcs_t* p, bool enable);
void NthwMacPcs_txSendRfi(NthwMacPcs_t* p, bool enable);
bool NthwMacPcs_isDDR3CalibDone(NthwMacPcs_t* p);
void NthwMacPcs_TxHostEnable(NthwMacPcs_t* p, bool enable); // wrapper - for ease of use
void NthwMacPcs_setRxEnable(NthwMacPcs_t* p, bool enable);
void NthwMacPcs_setTxEnable(NthwMacPcs_t* p, bool enable);
void NthwMacPcs_setTxSelHost(NthwMacPcs_t* p, bool enable);
void NthwMacPcs_setTxSelTfg(NthwMacPcs_t* p, bool enable);
void NthwMacPcs_setTsEop(NthwMacPcs_t* p, bool enable);
void NthwMacPcs_setHostLoopback(NthwMacPcs_t* p, bool enable);
void NthwMacPcs_setLineLoopback(NthwMacPcs_t* p, bool enable);
void NthwMacPcs_resetBIPCounters(NthwMacPcs_t* p);
void NthwMacPcs_getStatus(NthwMacPcs_t* p, uint8_t *status);
bool NthwMacPcs_getHiBer(NthwMacPcs_t* p);

void NthwMacPcs_getLinkSummary1(NthwMacPcs_t* p,
                    uint32_t* pStatus,
                    uint32_t* pStatusLatch,
                    uint32_t* pAligned,
                    uint32_t* pLocalFault,
                    uint32_t* pRemoteFault);

void NthwMacPcs_getLinkSummary(NthwMacPcs_t* p,
                    uint32_t* pAbs,
                    uint32_t* pNtPhyLinkState,
                    uint32_t* pLhAbs,
                    uint32_t* pLlNtPhyLinkState,
                    uint32_t* pLinkDownCnt,
                    uint32_t* pNimInterr,
                    uint32_t* pLhLocalFault,
                    uint32_t* pLhRemoteFault,
                    uint32_t* pLocalFault,
                    uint32_t* pRemoteFault);


bool NthwMacPcs_resetRequired(NthwMacPcs_t* p);
void NthwMacPcs_setFec(NthwMacPcs_t* p, bool enable);
bool NthwMacPcs_getFecBypass(NthwMacPcs_t* p);
bool NthwMacPcs_getFecValid(NthwMacPcs_t* p);
bool NthwMacPcs_getFecAligned(NthwMacPcs_t* p);
bool NthwMacPcs_getFecStatAnyAmLocked(NthwMacPcs_t* p);
bool NthwMacPcs_getFecStatAllAmLocked(NthwMacPcs_t* p);
void NthwMacPcs_dumpFecStatFields(NthwMacPcs_t* p);
void NthwMacPcs_resetFecCounters(NthwMacPcs_t* p);
bool NthwMacPcs_getGtyRxBufStatError(NthwMacPcs_t* p);
void NthwMacPcs_setGtyTxTuning(NthwMacPcs_t* p, uint8_t lane, uint8_t txPreCsr, uint8_t txDiffCtl, uint8_t txPostCsr);
void NthwMacPcs_swapGtyTxPolarity(NthwMacPcs_t* p, uint8_t lane, bool swap );
void NthwMacPcs_swapGtyRxPolarity(NthwMacPcs_t* p, uint8_t lane, bool swap );
void NthwMacPcs_setReceiverEqualizationMode(NthwMacPcs_t* p, uint8_t mode);
void NthwMacPcs_setLEDMode(NthwMacPcs_t* p, uint8_t mode);
void NthwMacPcs_setTimestampCompRx(NthwMacPcs_t* p, uint16_t rxDly);
void NthwMacPcs_setPortNo(NthwMacPcs_t* p, uint8_t portNo);

uint32_t NthwMacPcs_getFldBlockLockLock(NthwMacPcs_t* p);
uint32_t NthwMacPcs_getFldBlockLockLockMask(NthwMacPcs_t* p);
uint32_t NthwMacPcs_getFldLaneLockLock(NthwMacPcs_t* p);
uint32_t NthwMacPcs_getFldLaneLockLockMask(NthwMacPcs_t* p);


//
//
//
#endif // NTHW_MAC_PCS_H_

//
// EOF
//
