//
// nthw_mac_rx.h
//

/*
 * %NT_SOFTWARE_LICENSE%
 */

//
//
//
#ifndef NTHW_MAC_RX_H_
#define NTHW_MAC_RX_H_



//
//
//
struct NthwMacRx
{
  Fpga_t* mpFpga;
  //
  Module_t* mpModMacRx;
  //
  int mnInstance;

  //
  uint32_t mFirstValue;
  uint32_t mLarstValue;
  uint64_t mAddValue;
  bool mFirstTime;

  //
  Field_t* mpFldBadFcsCount;

  Field_t* mpFldTotalPacketsCount;
  Field_t* mpFldTotalGoodPacketsCount;
  //
  Field_t* mpFldPacketSmallCount;
  //
  Field_t* mpFldTotalBytesCount;
  Field_t* mpFldTotalGoodBytesCount;
  //
  Field_t* mpFldPacketBadFcsCount;
  Field_t* mpFldUndersizeCount;

};

typedef struct NthwMacRx NthwMacRx_t;
typedef struct NthwMacRx NthwMacRx;

//
//
//
NthwMacRx_t* NthwMacRx_new(void);
void NthwMacRx_delete(NthwMacRx_t* p);
int NthwMacRx_init(NthwMacRx_t *p, Fpga_t *pFpga, int nInstance);
//
uint64_t NthwMacRx_getBadFcsCount(NthwMacRx_t* p);
uint64_t NthwMacRx_getTotalBytesCount(NthwMacRx_t* p);
uint64_t NthwMacRx_getTotalGoodBytesCount(NthwMacRx_t* p);
uint64_t NthwMacRx_getTotalPacketsCount(NthwMacRx_t* p);
uint64_t NthwMacRx_getTotalGoodPacketsCount(NthwMacRx_t* p);
uint64_t NthwMacRx_getPacketSmallCount(NthwMacRx_t* p);
uint64_t NthwMacRx_getPacketBadFcsCount(NthwMacRx_t* p);
//
uint64_t NthwMacRx_getRxUndersizeCount(NthwMacRx_t* p);
//
//
//
#endif // NTHW_MAC_RX_H_

//
// EOF
//
