//
// nthw_mac_tfg.h
//

/*
 * %NT_SOFTWARE_LICENSE%
 */

//
//
//
#ifndef NTHW_MAC_TFG_H_
#define NTHW_MAC_TFG_H_



//
//
//
struct NthwMacTfg
{
  Fpga_t* mpFpga;
  //
  Module_t* mpModMacTfg;
  //
  int mnInstance;

  // Params
  int mnIfgSpeedMul;
  int mnIfgSpeedDiv;

  // TFG
  Register_t* mpRegTfgData;
  Register_t* mpRegTfgAddr;
  Register_t* mpRegTfgCtrl;
  Register_t* mpRegTfgRepetition;

  // TFG ADDR
  Field_t* mpFldTfgAddrWriteRAMAdr;
  Field_t* mpFldTfgAddrReadEnable;
  Field_t* mpFldTfgAddrReadDone;

  // TFG DATA
  Field_t* mpFldTfgDataLength;
  Field_t* mpFldTfgDataGap;
  Field_t* mpFldTfgDataId;

  // TFG CTRL
  Field_t* mpFldTfgWrap;
  Field_t* mpFldTfgRestart;
  Field_t* mpFldTfgEnable;
  Field_t* mpFldTfgTimeMode;
  Field_t* mpFldTfgIdPos;
  Field_t* mpFldTfgIdEna;
  Field_t* mpFldTfgTxActive;

  // TFG REPETITION
  Field_t* mpFldTfgRepetitionCount;

};

typedef struct NthwMacTfg NthwMacTfg_t;
typedef struct NthwMacTfg NthwMacTfg;

//
//
//


NthwMacTfg_t* NthwMacTfg_new(void);
void NthwMacTfg_delete(NthwMacTfg_t* p);
int NthwMacTfg_init(NthwMacTfg_t *p, Fpga_t *pFpga, int nInstance);
//
void NthwMacTfg_TfgTxStart(NthwMacTfg_t* p, uint32_t repetition, uint32_t size, uint32_t pkt_gap);
void NthwMacTfg_TfgTxStop(NthwMacTfg_t* p);
//
bool NthwMacTfg_isTfgTransmitting(NthwMacTfg_t* p);
//
double NthwMacTfg_getTfgRateFactor(NthwMacTfg_t* p);
double NthwMacTfg_getTfgGapFactor(NthwMacTfg_t* p);

//
//
//
#endif // NTHW_MAC_TFG_H_

//
// EOF
//
