//
// nthw_pci_rd_tg.h
//

/*
 * %NT_LICENSE%
 */

#ifndef __NTHW_PCI_RD_TG_H__
#define __NTHW_PCI_RD_TG_H__

//
// Includes:
//

//
//
//
struct NthwPciRdTg
{
  Fpga_t* mpFpga;
  //
  Module_t* mpModPciRdTg;
  //
  int mnInstance;
  //
  int mnParamPciTaTgPresent;
  //
  Register_t* mpRegPciRdTgRdData0;
  Field_t* mpFldPciRdTgPhysAddrLow;
  //
  Register_t* mpRegPciRdTgRdData1;
  Field_t* mpFldPciRdTgPhysAddrHigh;
  //
  Register_t* mpRegPciRdTgRdData2;
  Field_t* mpFldPciRdTgReqSize;
  Field_t* mpFldPciRdTgReqHid;
  Field_t* mpFldPciRdTgWait;
  Field_t* mpFldPciRdTgWrap;
  //
  Register_t* mpRegPciRdTgRdAddr;
  Field_t* mpFldPciRdTgRamAddr;
  //
  Register_t* mpRegPciRdTgRdRun;
  Field_t* mpFldPciRdTgRunIteration;
  //
  Register_t* mpRegPciRdTgRdCtrl;
  Field_t* mpFldPciRdTgCtrlRdy;
  //
};

typedef struct NthwPciRdTg NthwPciRdTg_t;
typedef struct NthwPciRdTg NthwPciRdTg;

//
//
//
NthwPciRdTg_t* NthwPciRdTg_new(void);
void NthwPciRdTg_delete(NthwPciRdTg_t* p);
int NthwPciRdTg_init(NthwPciRdTg_t* p, Fpga_t* pFpga, int nInstance);
//
void NthwPciRdTg_setPhysAddr(NthwPciRdTg_t* p, uint64_t nPhysAddr);
void NthwPciRdTg_setRamAddr(NthwPciRdTg_t* p, int nRamAddr);
void NthwPciRdTg_setRamData(NthwPciRdTg_t* p, uint32_t reqSize, bool wait, bool wrap);
void NthwPciRdTg_setRun(NthwPciRdTg_t* p, int nIterations);
uint32_t NthwPciRdTg_getCtrlRdy(NthwPciRdTg_t* p);

//
//
//

#endif // __NTHW_PCI_RD_TG_H__


//
// EOF
//
