//
// nthw_pci_wr_tg.h
//


/*
 * %NT_LICENSE%
 */

#ifndef __NTHW_PCI_WR_TG_H__
#define __NTHW_PCI_WR_TG_H__


//
// Includes:
//

//
//
//
struct NthwPciWrTg
{
  Fpga_t* mpFpga;
  //
  Module_t* mpModPciWrTg;
  //
  int mnInstance;
  //
  //
  int mnParamPciTaTgPresent;
  //
  Register_t* mpRegPciWrTgData0;
  Field_t* mpFldPciWrTgPhysAddrLow;
  //
  Register_t* mpRegPciWrTgData1;
  Field_t* mpFldPciWrTgPhysAddrHigh;
  //
  Register_t* mpRegPciWrTgData2;
  Field_t* mpFldPciWrTgReqSize;
  Field_t* mpFldPciWrTgReqHid;
  Field_t* mpFldPciWrTgIncMode;
  Field_t* mpFldPciWrTgWait;
  Field_t* mpFldPciWrTgWrap;
  //
  Register_t* mpRegPciWrTgAddr;
  Field_t* mpFldPciWrTgRamAddr;
  //
  Register_t* mpRegPciWrTgRun;
  Field_t* mpFldPciWrTgRunIteration;
  //
  Register_t* mpRegPciWrTgCtrl;
  Field_t* mpFldPciWrTgCtrlRdy;
  //
  Register_t* mpRegPciWrTgSeq;
  Field_t* mpFldPciWrTgSeqSequence;
  //
};

typedef struct NthwPciWrTg NthwPciWrTg_t;
typedef struct NthwPciWrTg NthwPciWrTg;

//
//
//
NthwPciWrTg_t* NthwPciWrTg_new(void);
void NthwPciWrTg_delete(NthwPciWrTg_t* p);
int NthwPciWrTg_init(NthwPciWrTg_t* p, Fpga_t* pFpga, int nInstance);
//
void NthwPciWrTg_setPhysAddr(NthwPciWrTg_t* p, uint64_t nPhysAddr);
void NthwPciWrTg_setRamAddr(NthwPciWrTg_t* p, int nRamAddr);
void NthwPciWrTg_setRamData(NthwPciWrTg_t* p, uint32_t reqSize, bool wait, bool wrap, bool inc);
void NthwPciWrTg_setRun(NthwPciWrTg_t* p, int nIterations);
uint32_t NthwPciWrTg_getCtrlRdy(NthwPciWrTg_t* p);

//
//
//

#endif // __NTHW_PCI_WR_TG_H__

//
// EOF
//
