//
// nthw_pcie3.h
//

/*
 * %NT_SOFTWARE_LICENSE%
 */


#ifndef __NTHW_PCIE3_H__
#define __NTHW_PCIE3_H__

//
//
//
struct NthwPcie3
{
  Fpga_t* mpFpga;
  //
  Module_t* mpModPcie3;
  //
  int mnInstance;
  //
  Register_t* mpRegStatCtrl;
  Field_t* mpFldStatCtrlReq;
  Field_t* mpFldStatCtrlEna;
  //
  Register_t* mpRegStatRx;
  Field_t* mpFldStatRxCounter;
  //
  Register_t* mpRegStatTx;
  Field_t* mpFldStatTxCounter;
  //
  Register_t* mpRegStatRqRdy;
  Field_t* mpFldStatRqRdyCounter;
  //
  Register_t* mpRegStatRqVld;
  Field_t* mpFldStatRqVldCounter;
  //
  Register_t* mpRegStatus0;
  Field_t* mpFldStatus0TagsInUse;
  //
  Register_t* mpRegStatRefClk;
  Field_t* mpFldStatRefClkRefClk;
  //
  Register_t* mpRegRpToEpErr;
  Field_t* mpFldRpToEpErrCor;
  Field_t* mpFldRpToEpErrNonFatal;
  Field_t* mpFldRpToEpErrFatal;
  //
  Register_t* mpRegEpToRpErr;
  Field_t* mpFldEpToRpErrCor;
  Field_t* mpFldEpToRpErrNonFatal;
  Field_t* mpFldEpToRpErrFatal;
  //
  Register_t* mpRegSampleTime;
  Field_t* mpFldSampleTime;
  //
  Register_t* mpRegPciEndPoint;
  Field_t* mpFldPciEndPointIfId;
  Field_t* mpFldPciEndPointSendMsg;
  Field_t* mpFldPciEndPointGetMsg;
  Field_t* mpFldPciEndPointDMAEP0AllowMask;
  Field_t* mpFldPciEndPointDMAEP1AllowMask;
  //
  Register_t* mpRegPciE3MarkAdrLsb;
  Field_t* mpFldPciE3MarkAdrLsbAdr;
  //
  Register_t* mpRegPciE3MarkAdrMsb;
  Field_t* mpFldPciE3MarkAdrMsbAdr;
  //
  Register_t* mpRegPciTest0;
  Field_t* mpFldPciTest0;
  //
  Register_t* mpRegPciTest1;
  Field_t* mpFldPciTest1;
  //
  Register_t* mpRegPciTest2;
  Field_t* mpFldPciTest2;
  //
  Register_t* mpRegPciTest3;
  Field_t* mpFldPciTest3;
  //
};

typedef struct NthwPcie3 NthwPcie3_t;
typedef struct NthwPcie3 NthwPcie3;


//
//
//
NthwPcie3_t* NthwPcie3_new(void);
void NthwPcie3_delete(NthwPcie3_t* p);
int NthwPcie3_init(NthwPcie3_t* p, Fpga_t* pFpga, int nInstance);
//
int NthwPcie3_trigger_sample_time(NthwPcie3_t* p);
//
int NthwPcie3_StatReqEnable(NthwPcie3_t* p);
int NthwPcie3_StatReqDisable(NthwPcie3_t* p);
//int NthwPcie3_StatSample(NthwPcie3_t* p, uint64_t* pRxRate, uint64_t* pTxRate, uint64_t* pRefClkCnt, uint64_t* pTagsInUse, uint64_t* pRdErrCnt, uint64_t* pWrErrCnt);
//

int NthwPcie3_getStat(NthwPcie3_t* p, uint32_t* pRxCnt, uint32_t* pTxCnt, uint32_t* pRefClkCnt, uint32_t* pTgUnitSize, uint32_t* pTgRefFreq, uint32_t* pTagUseCnt, uint32_t* pRqRdyCnt, uint32_t* pRqVldCnt);
int NthwPcie3_getStatRate(NthwPcie3_t* p, uint64_t* pPciRxRate, uint64_t* pPciTxRate, uint64_t* pRefClkCnt, uint64_t* pTagUseCnt, uint64_t* pPciNtBusUtil, uint64_t* pPciXilBusUtil);
//
int NthwPcie3_EndPointCountersSamplePre(NthwPcie3_t* p, struct NthwHif_EndPointCounters* epc);
int NthwPcie3_EndPointCountersSamplePost(NthwPcie3_t* p, struct NthwHif_EndPointCounters* epc);
//
//
//
#endif // __NTHW_PCIE3_H__


//
// EOF
//
