//
// nthw_mac100.hpp
//

/*
 * %NT_SOFTWARE_LICENSE%
 */

#ifndef NTHW_PHY10G_H_
#define NTHW_PHY10G_H_


//
//
//
struct NthwPhy10g
{
  //
  Fpga_t* mpFpga;
  //
  Module_t* mpModPhy10g;
  //
  int mnInstance;

  //
  Field_t* mpLinkSummaryAbs;
  Field_t* mpLinkSummaryNtLinkState;
  Field_t* mpLinkSummaryRes;
  Field_t* mpLinkSummaryLinkDownCnt;

  //
  Field_t* mpCtrlSoftReset;
  Field_t* mpCtrlLinkupLatency;
  Field_t* mpCtrlForceLinkDown;
  Field_t* mpCtrlLineLoopback;
  Field_t* mpCtrlHostLoopback;

  //
  Field_t* mpCoreConfPmaLoopback;
  Field_t* mpCoreConfPmaReset;
  Field_t* mpCoreConfGlobalTxDisable;
  Field_t* mpCoreConfPcsLoopback;
  Field_t* mpCoreConfPcsReset;
  Field_t* mpCoreConfDataPattSel;
  Field_t* mpCoreConfTestPattSel;
  Field_t* mpCoreConfRxTestPattEn;
  Field_t* mpCoreConfTxTestPattEn;
  Field_t* mpCoreConfPrbs31TxEn;
  Field_t* mpCoreConfPrbs31RxEn;
  Field_t* mpCoreConfSetPmaLinkStatus;
  Field_t* mpCoreConfClearPmaPmdLinkFaults;
  Field_t* mpCoreConfSetPcsLinkStatus;
  Field_t* mpCoreConfClearPcsLinkFaults;
  Field_t* mpCoreConfClearPcsStatus2;
  Field_t* mpCoreConfClearTestPattErrCount;
  Field_t* mpCoreConfNtLinkupLatency;
  Field_t* mpCoreConfNtForceLinkDown;
  Field_t* mpCoreConfTxDisable;

  //
  Field_t* mpCoreStatPcsBlockLock;
  Field_t* mpCoreStatPmaReset;
  Field_t* mpCoreStatPmaPmdLinkStat;
  Field_t* mpCoreStatPmaPmdRxFault;
  Field_t* mpCoreStatPmaPmdTxFault;
  Field_t* mpCoreStatRxSigDet;
  Field_t* mpCoreStatPcsRxLinkStatus;
  Field_t* mpCoreStatPcsRxFault;
  Field_t* mpCoreStatPcsTxFault;
  Field_t* mpCoreStatPcsRxLocked;
  Field_t* mpCoreStatPcsHiber;
  Field_t* mpCoreStatTengPcsRxLinkStatus;
  Field_t* mpCoreStatNtLinkState;
  Field_t* mpCoreStatPcsErrBlockCount;
  Field_t* mpCoreStatPcsBerCount;
  Field_t* mpCoreStatPcsRxHiberLh;
  Field_t* mpCoreStatPcsRxLockedLl;
  Field_t* mpCoreStatPcsTestPattErrCount;
  Field_t* mpCoreStatPcsReset;

  //
  Field_t* mpGpioPwrEn;
  Field_t* mpGpioAbs;
  Field_t* mpGpioRxLos;
  Field_t* mpGpioTxFault;
  Field_t* mpGpioLedMode;
  Field_t* mpGpioLedModeNim;
  Field_t* mpGpioLedModePhy;

  //
  Field_t* mpIntEn;
  Field_t* mpIntMaxPace;

  //
  Field_t* mpGtCtrlEyescanreset;
  Field_t* mpGtCtrlEyescantrigger;
  Field_t* mpGtCtrlRxcdrhold;
  Field_t* mpGtCtrlTxprbsforceerr;
  Field_t* mpGtCtrlRxrate;
  Field_t* mpGtCtrlTxpmareset;
  Field_t* mpGtCtrlRxpmareset;
  Field_t* mpGtCtrlRxdfelpmreset;
  Field_t* mpGtCtrlTxprecursor;
  Field_t* mpGtCtrlTxpostcursor;
  Field_t* mpGtCtrlTxdiffctrl;
  Field_t* mpGtCtrlRxlpmen;

  //
  Field_t* mpGtStatEyescandataerror;
  Field_t* mpGtStatTxbufstatus;
  Field_t* mpGtStatTxresetdone;
  Field_t* mpGtStatRxpmaresetdone;
  Field_t* mpGtStatRxresetdone;
  Field_t* mpGtStatRxbufstatus;
  Field_t* mpGtStatRxprbserr;
  Field_t* mpGtStatDmonitorout;

  Field_t* mpTsComp;

};

typedef struct NthwPhy10g NthwPhy10g_t;
typedef struct NthwPhy10g NthwPhy10g;

//
//
//
NthwPhy10g_t* NthwPhy10g_new(void);
void NthwPhy10g_delete(NthwPhy10g_t* p);
int NthwPhy10g_init(NthwPhy10g_t *p, Fpga_t *pFpga, int nInstance);
//
void NthwPhy10g_moduleDetect(NthwPhy10g_t* p, bool* modDetect);
void NthwPhy10g_nimPower(NthwPhy10g_t* p, bool enable);
void NthwPhy10g_linkStatus(NthwPhy10g_t* p, bool* pCurrent, bool* latched);
void NthwPhy10g_resetLatchedBits(NthwPhy10g_t* p);
void NthwPhy10g_nimTxlaser(NthwPhy10g_t* p, bool enable);
void NthwPhy10g_getTxlaser(NthwPhy10g_t* p, bool *pEnable);
void NthwPhy10g_signalDetect(NthwPhy10g_t* p, bool *sigDetect);
void NthwPhy10g_portStatus(NthwPhy10g_t* p, bool* pCurrent, bool* modDetect, uint32_t* linkDownCnt);

void NthwPhy10g_setLedMode(NthwPhy10g_t* p, uint8_t mode);
void NthwPhy10g_setPmaLoopback(NthwPhy10g_t* p, bool enable);
void NthwPhy10g_setPcsLoopback(NthwPhy10g_t* p, bool enable);
void NthwPhy10g_setTxEye(NthwPhy10g_t* p, uint8_t pre, uint8_t post, uint8_t diff);
void NthwPhy10g_forceLinkDown(NthwPhy10g_t* p, bool enable);
void NthwPhy10g_TxDisable(NthwPhy10g_t* p, bool enable);
void NthwPhy10g_getTxDisable(NthwPhy10g_t* p, bool *pEnable);
void NthwPhy10g_SetHostLoopback(NthwPhy10g_t* p, bool enable);
void NthwPhy10g_SetLineLoopback(NthwPhy10g_t* p, bool enable);
void NthwPhy10g_SetTsCompRx(NthwPhy10g_t* p, uint16_t rxDly);

//
//
//
#endif // NTHW_PHY3S10G_H_

//
// EOF
//
