//
// nthw_phy3s10g.h
//

/*
 * %NT_SOFTWARE_LICENSE%
 */

#ifndef NTHW_PHY3S10G_H_
#define NTHW_PHY3S10G_H_


struct NthwPhy3s10g
{
  //
  Fpga_t* mpFpga;
  //
  Module_t* mpModPhy3s10g;
  //
  int mnInstance;
  //

  // Control
  //Field_t* mpRxEnable;
  //Field_t* mpRxPauseEnable;
  //Field_t* mpTxEnable;
  //Field_t* mpTxPauseEnable;
  //Field_t* mpStrEnable;

  // MAC Address
  //Field_t* mpMacAddrLower;
  //Field_t* mpMacAddrUpper;


  // Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) LINK_SUMMARY register
  Field_t* mpLinkSummaryAbs;
  Field_t* mpLinkSummaryNtLinkState;
  Field_t* mpLinkSummaryAnegBypass;
  Field_t* mpLinkSummaryLinkDownCnt;

  // Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) CTRL register
  Field_t* mpCtrlPhySel;
  Field_t* mpCtrlPhyChangeFsmDone;
  Field_t* mpCtrlSoftReset;
  Field_t* mpCtrlLinkupLatency;
  Field_t* mpCtrlForceLinkDown;
  Field_t* mpCtrlLineLoopback_3s;
  Field_t* mpCtrlHostLoopback_3s;
  Field_t* mpCtrlLineLoopback_10g;
  Field_t* mpCtrlhostLoopback_10g;

  // Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) CORE_CONF_10G register
  Field_t* mpCoreConf10gPmaLoopback;
  Field_t* mpCoreConf10gPmaReset;
  Field_t* mpCoreConf10gPcsLoopback;
  Field_t* mpCoreConf10gPcsReset;
  Field_t* mpCoreConf10gSetPmaLinkStatus;
  Field_t* mpCoreConf10gClearPmaPmdLinkFaults;
  Field_t* mpCoreConf10gSetPcsLinkStatus;
  Field_t* mpCoreConf10gClearPcsLinkFaults;
  Field_t* mpCoreConf10gClearPcsStatus2;

  // Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) CORE_STAT_10G register
  Field_t* mpCoreStat10gPcsBlockLock;
  Field_t* mpCoreStat10gPmaPmdLinkStat;
  Field_t* mpCoreStat10gRxSigDet;
  Field_t* mpCoreStat10gPcsRxLinkStatus;
  Field_t* mpCoreStat10gPcsRxLocked;
  Field_t* mpCoreStat10gPcsHiber;
  Field_t* mpCoreStat10gTengPcsRxLinkStatus;
  Field_t* mpCoreStat10gNtLinkState;
  Field_t* mpCoreStat10gPcsErrBlockCount;
  Field_t* mpCoreStat10gPcsBerCount;
  Field_t* mpCoreStat10gPcsRxHiberLh;
  Field_t* mpCoreStat10gPcsRxLockedLl;

  // Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) CORE_CONF_3S register
  Field_t* mpCoreConf3sUnidirectEn;
  Field_t* mpCoreConf3sLoopbackCtrl;
  Field_t* mpCoreConf3sPowerDown;
  Field_t* mpCoreConf3sAnegEn;
  Field_t* mpCoreConf3sAnegRestart;
  Field_t* mpCoreConf3sBasexOrSgmii;
  Field_t* mpCoreConf3sSpeed;
  Field_t* mpCoreConf3sAnegBypassEn;
  Field_t* mpCoreConf3sLinkTimerBasex;

  // Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) CORE_STAT_3S register
  Field_t* mpCoreStat3sLinkStatus;
  Field_t* mpCoreStat3sLinkSync;
  Field_t* mpCoreStat3sRudiC;
  Field_t* mpCoreStat3sRudiI;
  Field_t* mpCoreStat3sRudiInvalid;
  Field_t* mpCoreStat3sRxdisperr;
  Field_t* mpCoreStat3sRxnotintable;
  Field_t* mpCoreStat3sPhyLinkStat;
  Field_t* mpCoreStat3sRemFaultEnc;
  Field_t* mpCoreStat3sSpeed;
  Field_t* mpCoreStat3sDuplexMode;
  Field_t* mpCoreStat3sReserved;
  Field_t* mpCoreStat3sPause;
  Field_t* mpCoreStat3sAnegComplete;
  Field_t* mpCoreStat3sNtLinkState;

  // Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) ANEG_ADV_3S register
  Field_t* mpAnegAdv3sDuplex;
  Field_t* mpAnegAdv3sPause;
  Field_t* mpAnegAdv3sRemoteFault;

  // Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) GPIO register
  Field_t* mpGpioAbs;
  Field_t* mpGpioRxLos;
  Field_t* mpGpioTxFault;
  Field_t* mpGpioLedMode;
  Field_t* mpGpioRateSel;
  Field_t* mpGpioTxDisable;

  // Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) INT register
  Field_t* mpIntEn;
  Field_t* mpIntMaxPace;

  // Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) GT_CR register
  Field_t* mpGtCrEyescanreset;
  Field_t* mpGtCrEyescantrigger;
  Field_t* mpGtCrRxcdrhold;
  Field_t* mpGtCrTxprbsforceerr;
  Field_t* mpGtCrTxpmareset;
  Field_t* mpGtCrRxpmareset;
  Field_t* mpGtCrTxprecursor;
  Field_t* mpGtCrTxpostcursor;
  Field_t* mpGtCrTxdiffctrl;
  Field_t* mpGtCrTxprbssel;
  Field_t* mpGtCrRxprbssel;
  Field_t* mpGtCrRxprbscntreset;
  Field_t* mpGtCrLoopback;
  Field_t* mpGtCrRxlpmen;
  Field_t* mpGtCrRxdfelpmreset;

  // Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) GT_SR register
  Field_t* mpGtSrTxresetdone;
  Field_t* mpGtSrRxresetdone;
  Field_t* mpGtSrRxpmaresetdone;
  Field_t* mpGtSrTxbufstatus;
  Field_t* mpGtSrRxbufstatus;
  Field_t* mpGtSrEyescandataerror;
  Field_t* mpGtSrRxprbserr;

  // Timestamp compensation for RX path delay
  Field_t* mpTsCompRx10g;
  Field_t* mpTsCompRx3S;

};

typedef struct NthwPhy3s10g NthwPhy3s10g_t;
typedef struct NthwPhy3s10g NthwPhy3s10g;

//
//
//
NthwPhy3s10g_t* NthwPhy3s10g_new(void);
void NthwPhy3s10g_delete(NthwPhy3s10g_t* p);
int NthwPhy3s10g_init(NthwPhy3s10g_t *p, Fpga_t *pFpga, int nInstance);
//
void NthwPhy3s10g_ResetLatchedBits(NthwPhy3s10g_t* p);
void NthwPhy3s10g_NimTxlaser(NthwPhy3s10g_t* p, bool enable);
void NthwPhy3s10g_GetNimTxlaser(NthwPhy3s10g_t* p, bool *pEnable);
void NthwPhy3s10g_ForceLinkDown(NthwPhy3s10g_t* p, bool forceDown);
void NthwPhy3s10g_HostLoopback3s(NthwPhy3s10g_t* p, bool enable);
void NthwPhy3s10g_LineLoopback3s(NthwPhy3s10g_t* p, bool enable);
void NthwPhy3s10g_HostLoopback10g(NthwPhy3s10g_t* p, bool enable);
void NthwPhy3s10g_LineLoopback10g(NthwPhy3s10g_t* p, bool enable);
void NthwPhy3s10g_PortStatus(NthwPhy3s10g_t* p, bool* pCurrent, bool *modDetect, uint32_t *linkDownCnt, bool *pAnegBypassed);
void NthwPhy3s10g_SetLedMode(NthwPhy3s10g_t* p, uint8_t mode);
void NthwPhy3s10g_SetTxEye(NthwPhy3s10g_t* p, uint8_t pre, uint8_t post, uint8_t diff);
void NthwPhy3s10g_Select(NthwPhy3s10g_t* p, uint8_t select);
void NthwPhy3s10g_ToggleSoftReset(NthwPhy3s10g_t* p);
void NthwPhy3s10g_GetPhyChangeFsmDone(NthwPhy3s10g_t* p, bool* pDone);
void NthwPhy3s10g_SetLinkupLatency(NthwPhy3s10g_t* p, uint32_t latency);
void NthwPhy3s10g_SetNimRate(NthwPhy3s10g_t* p, uint8_t rate);
void NthwPhy3s10g_GetGtSrTxResetDone(NthwPhy3s10g_t* p, bool*   pDone);
void NthwPhy3s10g_SetGtCrRxLpmEna(NthwPhy3s10g_t* p, bool rxLpmEna);
void NthwPhy3s10g_CoreConfAnegEna(NthwPhy3s10g_t* p, bool enable);
void NthwPhy3s10g_CoreConfAnegByPassEna(NthwPhy3s10g_t* p, bool enable);
void NthwPhy3s10g_SetCoreConfUseBasex(NthwPhy3s10g_t* p, bool useBasex);
void NthwPhy3s10g_SetCoreConfSpeed(NthwPhy3s10g_t* p, int speed); // NtLinkSpeed_e speed);
void NthwPhy3s10g_GetCoreStat3sSpeed(NthwPhy3s10g_t* p, int* pSpeed); // NtLinkSpeed_e *pSpeed);
void NthwPhy3s10g_AnegComplete(NthwPhy3s10g_t* p, bool *pComplete);
void NthwPhy3s10g_setTsCompRx10g(NthwPhy3s10g_t* p, uint16_t rxDly);
void NthwPhy3s10g_setTsCompRx3S(NthwPhy3s10g_t* p, uint16_t rxDly);

//
//
//
#endif // NTHW_PHY3S10G_H_

//
// EOF
//
