//
// nthw_pm.h
//

/*
 * %NT_SOFTWARE_LICENSE%
 */

#ifndef NTHW_PM_H_
#define NTHW_PM_H_

//
//
//
//
//
//
struct NthwPm
{
  Fpga_t* mpFpga;
  //
  Module_t* mpModPm;
  //
  int mnInstance;
  //

  Register_t* mpRegCtrl; // PM_CTRL
  Field_t* mpFldCtrlSwCleanDone; // PM_CTRL_SW_CLEAN_DONE

  //
  Register_t* mpRegRxTxSlowPtrBlkInterval; // PM_RX_TX_SLOW_POINTER_BLOCK_INTERVAL
  Field_t* mpFldRxTxSlowPtrBlkIntervalData; // PM_RX_TX_SLOW_POINTER_BLOCK_INTERVAL_D

  //
  Register_t* mpRegTxReadPtrBlkInterval; // PM_TX_READ_POINTER_BLOCK_INTERVAL
  Field_t* mpFldTxReadPtrBlkIntervalData; // PM_TX_READ_POINTER_BLOCK_INTERVAL_D

  //
  Register_t* mpRegRxTxFastMemCtrl; // PM_RXTX_FAST_MEM_CTRL
  Field_t* mpFldRxTxFastMemCtrlAdr; // PM_RXTX_FAST_MEM_CTRL_A
  Field_t* mpFldRxTxFastMemCtrlCnt; // PM_RXTX_FAST_MEM_CTRL_CNT

  Register_t* mpRegRxTxFastMemData; // PM_RXTX_FAST_MEM_DATA
  Field_t* mpFldRxTxFastMemDataEntry; // PM_RXTX_FAST_MEM_DATA_ENTRY
  Field_t* mpFldRxTxFastMemDataHostBuffer; // PM_RXTX_FAST_MEM_DATA_HOST_BUFFER
  Field_t* mpFldRxTxFastMemDataRxTx; // PM_RXTX_FAST_MEM_DATA_RX_TX
  Field_t* mpFldRxTxFastMemDataVld; // PM_RXTX_FAST_MEM_DATA_VLD
  Field_t* mpFldRxTxFastMemDataBank; // PM_RXTX_FAST_MEM_DATA_BANK

  //
  Register_t* mpRegRxTxSlowMemCtrl; // PM_RXTX_SLOW_MEM_CTRL
  Field_t* mpFldRxTxSlowMemCtrlAdr; // PM_RXTX_SLOW_MEM_CTRL_A
  Field_t* mpFldRxTxSlowMemCtrlCnt; // PM_RXTX_SLOW_MEM_CTRL_CNT

  Register_t* mpRegRxTxSlowMemData; // PM_RXTX_SLOW_MEM_DATA
  Field_t* mpFldRxTxSlowMemDataEntry; // PM_RXTX_SLOW_MEM_DATA_ENTRY
  Field_t* mpFldRxTxSlowMemDataHostBuffer; // PM_RXTX_SLOW_MEM_DATA_HOST_BUFFER
  Field_t* mpFldRxTxSlowMemDataRxTx; // PM_RXTX_SLOW_MEM_DATA_RX_TX
  Field_t* mpFldRxTxSlowMemDataVld; // PM_RXTX_SLOW_MEM_DATA_VLD
  Field_t* mpFldRxTxSlowMemDataBank; // PM_RXTX_SLOW_MEM_DATA_BANK

  //
  Register_t* mpRegRxTxFastPtrBlkInterval; // PM_RX_TX_FAST_POINTER_BLOCK_INTERVAL
  Field_t* mpFldRxTxFastPtrBlkIntervalData; // PM_RX_TX_FAST_POINTER_BLOCK_INTERVAL_D

  //
  Register_t* mpRegPbiMemCtrl; // PM_PBI_MEM_CTRL
  Field_t* mpFldPbiMemCtrlAdr; // PM_PBI_MEM_CTRL_A
  Field_t* mpFldPbiMemCtrlCnt; // PM_PBI_MEM_CTRL_CNT

  Register_t* mpRegPbiMemData; // PM_PBI_MEM_DATA
  Field_t* mpFldPbiMemDataPhyAddr; // PM_PBI_MEM_DATA_PHYADDR
  Field_t* mpFldPbiMemDataSize; // PM_PBI_MEM_DATA_SIZE

  //
  Register_t* mpRegRxWpMemCtrl; // PM_RXWP_MEM_CTRL
  Field_t* mpFldRxWpMemCtrlAdr; // PM_RXWP_MEM_CTRL_A
  Field_t* mpFldRxWpMemCtrlCnt; // PM_RXWP_MEM_CTRL_CNT

  Register_t* mpRegRxWpMemData; // PM_RXWP_MEM_DATA
  Field_t* mpFldRxWpMemDataHostBuffer; // PM_RXWP_MEM_DATA_HOST_BUFFER
  Field_t* mpFldRxWpMemDataVld; // PM_RXWP_MEM_DATA_VLD
  Field_t* mpFldRxWpMemDataBank; // PM_RXWP_MEM_DATA_BANK
  Field_t* mpFldRxWpMemDataEntry; // PM_RXWP_MEM_DATA_ENTRY

  //
  Register_t* mpRegTxRpMemCtrl; // PM_TXRP_MEM_CTRL
  Field_t* mpFldTxRpMemCtrlAdr; // PM_TXRP_MEM_CTRL_A
  Field_t* mpFldTxRpMemCtrlCnt; // PM_TXRP_MEM_CTRL_CNT

  Register_t* mpRegTxRpMemData; // PM_TXRP_MEM_DATA
  Field_t* mpFldTxRpMemDataHostBuffer; // PM_TXRP_MEM_DATA_HOST_BUFFER
  Field_t* mpFldTxRpMemDataVld; // PM_TXRP_MEM_DATA_VLD
  Field_t* mpFldTxRpMemDataBank; // PM_TXRP_MEM_DATA_BANK
  Field_t* mpFldTxRpMemDataEntry; // PM_TXRP_MEM_DATA_ENTRY

  //
  Register_t* mpRegPointerBanks; // PM_POINTER_BANKS
  Field_t* mpFldPointerBanksData; // PM_POINTER_BANKS_D

  //
  Register_t* mpRegHbSizeRxThreshold; // PM_HB_SIZE_RX_THRESHOLD
  Field_t* mpFldHbSizeRxThresholdData; // PM_HB_SIZE_RX_THRESHOLD_D

  //
  Register_t* mpRegHbSizeRxMemData; // PM_HB_SIZE_RX_MEM_DATA
  Field_t* mpFldHbSizeRxMemDataSize; // PM_HB_SIZE_RX_MEM_DATA_SIZE

  Register_t* mpRegHbSizeRxMemCtrl; // PM_HB_SIZE_RX_MEM_CTRL
  Field_t* mpFldHbSizeRxMemCtrlAdr; // PM_HB_SIZE_RX_MEM_CTRL_A
  Field_t* mpFldHbSizeRxMemCtrlCnt; // PM_HB_SIZE_RX_MEM_CTRL_CNT

  //
  Register_t* mpRegRxWritePtrBlkInterval; // PM_RX_WRITE_POINTER_BLOCK_INTERVAL
  Field_t* mpFldRxWritePtrBlkIntervalData; // PM_RX_WRITE_POINTER_BLOCK_INTERVAL_D

  //
  Register_t* mpRegHbSizeTxThreshold; // PM_HB_SIZE_TX_THRESHOLD
  Field_t* mpFldHbSizeTxThresholdData; // PM_HB_SIZE_TX_THRESHOLD_D

  //
  Register_t* mpRegRxReader; // PM_RX_READER
  Field_t* mpFldRxReaderMask; // PM_RX_READER_MASK

  //
  Register_t* mpRegRxBlockedStatus; // PM_RX_BLOCKED_STATUS
  Field_t* mpFldRxBlockedStatusData; // PM_RX_BLOCKED_STATUS_D

  //
  Register_t* mpRegRxBlockedStatusHi; // PM_RX_BLOCKED_STATUS_HI
  Field_t* mpFldRxBlockedStatusHiData; // PM_RX_BLOCKED_STATUS_HI_D

};

typedef struct NthwPm NthwPm_t;
typedef struct NthwPm NthwPm;

//
//
//

//
//
//
NthwPm_t* NthwPm_new(void);
void NthwPm_delete(NthwPm_t* p);
int NthwPm_init(NthwPm_t* p, Fpga_t* pFpga, int nInstance);
//

void NthwPm_setCtrlSwCleanDone(NthwPm_t* p, uint32_t val);

void NthwPm_setPointerBanks(NthwPm_t* p, uint32_t val);

void NthwPm_setHbSizeRxTreshold(NthwPm_t* p, uint32_t val);

void NthwPm_setRxWritePtrBlkInterval(NthwPm_t* p, uint32_t val);
void NthwPm_setTxReadPtrBlkInterval(NthwPm_t* p, uint32_t val);

void NthwPm_setRxTxSlowPtrBlkInterval(NthwPm_t* p, uint32_t val);
void NthwPm_setRxTxFastPtrBlkInterval(NthwPm_t* p, uint32_t val);

void NthwPm_setRxTxSlowMem(NthwPm_t* p, uint32_t addr, int entry, int bank, int hb, int rxtx, int vld);
void NthwPm_setRxTxFastMem(NthwPm_t* p, uint32_t addr, int entry, int bank, int hb, int rxtx, int vld);

void NthwPm_setRxReaderMask(NthwPm_t* p, uint32_t* data, int len);

void NthwPm_getRxBlockedStatusMask(NthwPm_t* p, uint32_t* data, int len);

void NthwPm_setHbSizeRx(NthwPm_t* p, uint32_t addr, uint64_t size);

void NthwPm_setPbi(NthwPm_t* p, uint32_t addr, uint64_t dmaAddr, uint32_t size);

void NthwPm_setRxWp(NthwPm_t* p, uint32_t addr, int bank, int entry, int hb, int vld);

void NthwPm_setTxRp(NthwPm_t* p, uint32_t addr, int bank, int entry, int hb, int vld);


//
//
//
#endif // NTHW_PM_H_

//
// EOF
//
