//
// nthw_rbh.hpp
//

/*
 * %NT_SOFTWARE_LICENSE%
 */

#ifndef NTHW_RBH_H_
#define NTHW_RBH_H_

//
//
//
struct NthwRbh
{
  Fpga_t* mpFpga;
  //
  Module_t* mpModRbh;
  //
  int mnInstance;
  //
  int mnModuleMajorVersion;
  int mnModuleMinorVersion;
  //
  uint64_t mnModuleVersionPacked64;
  //

  //
  Register_t* mpRegCtrl;
  Field_t* mpFldCtrlEnableQmh;
  Field_t* mpFldCtrlEnablePM;
  Field_t* mpFldCtrlEnableMetaData;
  Field_t* mpFldCtrlReserved;
  Field_t* mpFldCtrlHbMax;
  Field_t* mpFldCtrlHbSegmentSize;

  Register_t* mpRegFlushAdrHi;
  Field_t* mpFldFlushAdrHiValue;

  Register_t* mpRegFlushAdrLo;
  Field_t* mpFldFlushAdrLoValue;

  Register_t* mpRegStatus;
  Field_t* mpFldStatusPwaDataFifoEmpty;
  Field_t* mpFldStatusBufferEmpty;

  Register_t* mpRegDebReg1;
  Field_t* mpFldDebReg1Value;

  Register_t* mpRegDebReg2;
  Field_t* mpFldDebReg2Value;

  Register_t* mpRegDebReg3;
  Field_t* mpFldDebReg3Value;

  Register_t* mpRegHostBufSizeMemCtrl;
  Field_t* mpFldHostBufSizeMemCtrlAdr;
  Field_t* mpFldHostBufSizeMemCtrlCnt;

  Register_t* mpRegHostBufSizeMemData;
  Field_t* mpFldHostBufSizeMemDataHbSegmentCnt;

  Register_t* mpRegWpSetMemCtrl;
  Field_t* mpFldWpSetMemCtrlAdr;
  Field_t* mpFldWpSetMemCtrlCnt;

  Register_t* mpRegWpSetMemData;
  Field_t* mpFldWpSetMemDataWp;

};

typedef struct NthwRbh NthwRbh_t;
typedef struct NthwRbh NthwRbh;

//
//
//
NthwRbh_t* NthwRbh_new(void);
void NthwRbh_delete(NthwRbh_t*);
int NthwRbh_init(NthwRbh_t *p, Fpga_t *pFpga, int nInstance);
//
void NthwRbh_setEnableQmh(NthwRbh_t* p, uint32_t enable);
void NthwRbh_setEnablePm(NthwRbh_t* p, uint32_t enable);
void NthwRbh_setEnableMetaData(NthwRbh_t* p, uint32_t enable);
//
void NthwRbh_setHostBufMax(NthwRbh_t* p, uint32_t hbMax);
void NthwRbh_setHostBufSegmentSize(NthwRbh_t* p, uint32_t hbSegSize);
//
void NthwRbh_setHostBufSegmentCount(NthwRbh_t* p, uint16_t addr, uint32_t hbSegCnt);
void NthwRbh_setWp(NthwRbh_t* p, uint16_t addr, uint64_t wpOffset);
void NthwRbh_setFlushAddr(NthwRbh_t* p, uint64_t flushAddr);
//
uint32_t NthwRbh_getStatusBufferEmpty(NthwRbh_t* p);
uint32_t NthwRbh_getStatusPwaDataFifoEmpty(NthwRbh_t* p);
uint32_t NthwRbh_getDeb1Value(NthwRbh_t* p);
uint32_t NthwRbh_getDeb2Value(NthwRbh_t* p);
uint32_t NthwRbh_getDeb3Value(NthwRbh_t* p);

//
//
//
#endif // NTHW_RBH_H_

//
// EOF
//
