//
// nthw_rmc.h
//

/*
 * %NT_SOFTWARE_LICENSE%
 */


#ifndef NTHW_RMC_H_
#define NTHW_RMC_H_

//
//
//
struct NthwRmc
{
  Fpga_t* mpFpga;
  //
  Module_t* mpModRmc;
  //
  int mnInstance;
  //
  int mnPorts;
  int mnNims;
  bool mbIsVswitch;
  //
  bool mbAdministrativeBlock;

  //
  // RMC CTRL register
  //
  Register_t* mpRegCtrl;
  Field_t* mpFldCtrlBlockStatDrop;
  Field_t* mpFldCtrlBlockKeepAlive;
  Field_t* mpFldCtrlBlockMacPort;

  //
  // RMC Status register
  //
  Register_t* mpRegStatus;
  Field_t* mpFldSfRamOf;
  Field_t* mpFldDescrFifoOf;

  //
  // RMC DBG register
  //
  Register_t* mpRegDbg;
  Field_t* mpFldDbgMerge;

  //
  // RMC MAC_IF register
  //
  Register_t* mpRegMacIf;
  Field_t* mpFldMacIfErr;
};

typedef struct NthwRmc NthwRmc_t;
typedef struct NthwRmc NthwRmc;

//
//
//
NthwRmc_t* NthwRmc_new(void);
void NthwRmc_delete(NthwRmc_t* p);
int NthwRmc_init(NthwRmc_t *p, Fpga_t *pFpga, int nInstance);
//
uint32_t NthwRmc_getMacBlock(NthwRmc_t* p);
void NthwRmc_setMacBlock(NthwRmc_t* p, uint32_t mask);
void NthwRmc_block(NthwRmc_t* p);
void NthwRmc_unblock(NthwRmc_t* p, bool bIsSlave);
void NthwRmc_administrativeBlock(NthwRmc_t* p);

uint32_t NthwRmc_getStatusSfRamOf(NthwRmc_t* p);
uint32_t NthwRmc_getStatusDescrFifoOf(NthwRmc_t* p);
uint32_t NthwRmc_getDbgMerge(NthwRmc_t* p);
uint32_t NthwRmc_getMacIfErr(NthwRmc_t* p);


//
//
//
#endif // NTHW_RMC_H_

//
// EOF
//
