//
// nthw_spim.h
//

/*
 * %NT_SOFTWARE_LICENSE%
 */

//
//
//

#ifndef __NTHW_SPIM_H__
#define __NTHW_SPIM_H__


//
//
//
struct NthwSpim
{
  Fpga_t* mpFpga;
  //
  Module_t* mpModSpim;
  //
  int mnInstance;
  //
  Register_t* mpReg_srr;
  Field_t* mpFld_srr_rst;
  //
  Register_t* mpReg_cr;
  Field_t* mpFld_cr_loop;
  Field_t* mpFld_cr_en;
  Field_t* mpFld_cr_txrst;
  Field_t* mpFld_cr_rxrst;
  //
  Register_t* mpReg_sr;
  Field_t* mpFld_sr_done;
  Field_t* mpFld_sr_txempty;
  Field_t* mpFld_sr_rxempty;
  Field_t* mpFld_sr_txfull;
  Field_t* mpFld_sr_rxfull;
  Field_t* mpFld_sr_txlvl;
  Field_t* mpFld_sr_rxlvl;
  //
  Register_t* mpReg_dtr;
  Field_t* mpFld_dtr_dtr;
  //
  Register_t* mpReg_drr;
  Field_t* mpFld_drr_drr;
  //
  Register_t* mpReg_cfg;
  Field_t* mpFld_cfg_pre;
  //

};

typedef struct NthwSpim NthwSpim_t;
typedef struct NthwSpim NthwSpim;

//
//
//
NthwSpim_t* NthwSpim_new(void);
int NthwSpim_init(NthwSpim_t* p, Fpga_t* pFpga, int nInstance);
void NthwSpim_delete(NthwSpim_t* p);
//
uint32_t NthwSpim_reset(NthwSpim_t* p);
uint32_t NthwSpim_enable(NthwSpim_t* p, bool bEnable);
uint32_t NthwSpim_get_tx_fifo_empty(NthwSpim_t* p, bool* pbEmpty);
uint32_t NthwSpim_write_tx_fifo(NthwSpim_t* p, uint32_t nData);
//

//
//
//
#endif // __NTHW_SPIM_H__

//
// EOF
//
