//
// nthw_spis.h
//

/*
 * %NT_SOFTWARE_LICENSE%
 */

//
//
//

#ifndef __NTHW_SPIS_H__
#define __NTHW_SPIS_H__


//
//
//
struct NthwSpis
{
  Fpga_t* mpFpga;
  //
  Module_t* mpModSpis;
  //
  int mnInstance;
  //
  Register_t* mpReg_srr;
  Field_t* mpFld_srr_rst;
  //
  Register_t* mpReg_cr;
  Field_t* mpFld_cr_loop;
  Field_t* mpFld_cr_en;
  Field_t* mpFld_cr_txrst;
  Field_t* mpFld_cr_rxrst;
  Field_t* mpFld_cr_debug;
  //
  Register_t* mpReg_sr;
  Field_t* mpFld_sr_done;
  Field_t* mpFld_sr_txempty;
  Field_t* mpFld_sr_rxempty;
  Field_t* mpFld_sr_txfull;
  Field_t* mpFld_sr_rxfull;
  Field_t* mpFld_sr_txlvl;
  Field_t* mpFld_sr_rxlvl;
  Field_t* mpFld_sr_frame_err;
  Field_t* mpFld_sr_read_err;
  Field_t* mpFld_sr_write_err;
  //
  Register_t* mpReg_dtr;
  Field_t* mpFld_dtr_dtr;
  //
  Register_t* mpReg_drr;
  Field_t* mpFld_drr_drr;
  //
  Register_t* mpReg_ram_ctrl;
  Field_t* mpFld_ram_ctrl_adr;
  Field_t* mpFld_ram_ctrl_cnt;
  //
  Register_t* mpReg_ram_data;
  Field_t* mpFld_ram_data_data;
  //
};

typedef struct NthwSpis NthwSpis_t;
typedef struct NthwSpis NthwSpis;

//
//
//
NthwSpis_t* NthwSpis_new(void);
int NthwSpis_init(NthwSpis_t* p, Fpga_t* pFpga, int nInstance);
void NthwSpis_delete(NthwSpis_t* p);
//
uint32_t NthwSpis_reset(NthwSpis_t* p);
uint32_t NthwSpis_enable(NthwSpis_t* p, bool bEnable);
uint32_t NthwSpis_get_rx_fifo_empty(NthwSpis_t* p, bool* pbEmpty);
uint32_t NthwSpis_read_rx_fifo(NthwSpis_t* p, uint32_t* pData);
uint32_t NthwSpis_read_sensor(NthwSpis_t* p, uint8_t nResultIdx, uint32_t* pSensorResult);
//
//

//
//
//
#endif // __NTHW_SPIS_H__

//
// EOF
//
