//
// nthw_tsm.h
//

/*
 * %NT_SOFTWARE_LICENSE%
 */


#ifndef __NTHW_TSM_H__
#define __NTHW_TSM_H__

//
//
//
struct NthwTsm
{
  Fpga_t* mpFpga;
  //
  Module_t* mpModTsm;
  //
  int mnInstance;
  //
  Field_t* mpFldConfigTsFormat;
  //
  Field_t* mpFldTimerCtrlTimerEnT0;
  Field_t* mpFldTimerCtrlTimerEnT1;
  //
  Field_t* mpFldTimerTimerT0MaxCount;
  //
  Field_t* mpFldTimerTimerT1MaxCount;
  //
  Register_t* mpRegTsLo;
  Field_t* mpFldTsLo;
  //
  Register_t* mpRegTsHi;
  Field_t* mpFldTsHi;
  //
  Register_t* mpRegTimeLo;
  Field_t* mpFldTimeLo;
  //
  Register_t* mpRegTimeHi;
  Field_t* mpFldTimeHi;
  //
};


typedef struct NthwTsm NthwTsm_t;
typedef struct NthwTsm NthwTsm;


//
//
//
NthwTsm_t* NthwTsm_new(void);
void NthwTsm_delete(NthwTsm_t* p);
int NthwTsm_init(NthwTsm_t *p, Fpga_t *pFpga, int nInstance);
//
int NthwTsm_getTs(NthwTsm_t* p, uint64_t* pTs);
int NthwTsm_getTime(NthwTsm_t* p, uint64_t* pTime);
int NthwTsm_setTime(NthwTsm_t* p, uint64_t nTime);
//
int NthwTsm_setTimerT0Enable(NthwTsm_t* p, bool bEnable);
int NthwTsm_setTimerT0MaxCount(NthwTsm_t* p, uint32_t nTimerVal);
int NthwTsm_setTimerT1Enable(NthwTsm_t* p, bool bEnable);
int NthwTsm_setTimerT1MaxCount(NthwTsm_t* p, uint32_t nTimerVal);
//
int NthwTsm_setConfigTsFormat(NthwTsm_t* p, uint32_t nVal);

//
//
//
#endif // __NTHW_TSM_H__

//
// EOF
//
