//
//
//

#include "nthw_drv.h"
#include "flow_filter.h"
#include "flow_api_backend.h"
#include "flow_backend.h"
#include "flow_api_nic_setup.h"


int FlowFilterInit(Fpga_t* pFpga, struct flow_nic_dev** pFlowDevice, int adapterNo)
{
  void *be_dev = NULL;
  struct flow_nic_dev *flow_nic;

  NT_LOG(DBG, FILTER, "Initializing flow filter api\n");
  const struct flow_api_backend_ops *iface = BinFlowBackendInit(pFpga, &be_dev);

  flow_nic = flow_api_create((uint8_t)adapterNo, iface, be_dev);
  if (!flow_nic) {
    *pFlowDevice = NULL;
    return -1;
  }
  *pFlowDevice = flow_nic;
  return 0;

}

int FlowFilterDone(struct flow_nic_dev *dev)
{
  void *be_dev = flow_api_get_be_dev(dev);

  int res = flow_api_done(dev);
  if (be_dev) {
    BinFlowBackendDone(be_dev);
  }
  return res;
}

//
// EOF
//
