//
// flow_nthw_cat.h
//

#ifndef __FLOW_NTHW_CAT_H__
#define __FLOW_NTHW_CAT_H__

#include <stdint.h> // uint32_t
#include "nthw_fpga_model.h"

struct CatNthw;

typedef struct CatNthw CatNthw_t;
// typedef struct CatNthw CatNthw;

//
//
//
struct CatNthw *CatNthw_new(void);
void CatNthw_delete(struct CatNthw *p);
int CatNthw_init(struct CatNthw *p, Fpga_t *pFpga, int nInstance);
//
int CatNthw_setup(struct CatNthw *p, int nIdx, int nIdxCnt);
void catNthw_setDebugMode(struct CatNthw *p, unsigned nDebugMode);
//

#if 0
  uint32_t GetVersionMajor(void) {return (mCat.getVersion()).getMajorVersion();}
  uint32_t GetVersionMinor(void) {return (mCat.getVersion()).getMinorVersion();}
  void SetDebugOutput(int on) {if (on) mCat.setDebugMode(Register_t::ON_WRITE); else mCat.setDebugMode(Register_t::NO_DEBUG);}
#endif

// CFN
void CatNthw_CfnSelect(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnCnt(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnEnable(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnInv(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcInv(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcIsl(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcCfp(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcMac(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcL2(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcVnTag(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcVlan(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcMpls(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcL3(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcFrag(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcIpProt(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcL4(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcTunnel(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcTnlL2(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcTnlVlan(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcTnlMpls(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcTnlL3(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcTnlFrag(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcTnlIpProt(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPtcTnlL4(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnErrInv(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnErrCv(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnErrFcs(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnErrTrunc(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnErrL3Cs(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnErrL4Cs(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnErrTnlL3Cs(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnErrTnlL4Cs(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnErrTtlExp(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnErrTnlTtlExp(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnMacPort(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPmCmp(const struct CatNthw *p, const uint32_t *val);
void CatNthw_CfnPmDct(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPmExtInv(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPmCmb(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPmAndInv(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPmOrInv(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnPmInv(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnLc(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnLcInv(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnKm0Or(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnKm1Or(const struct CatNthw *p, uint32_t val);
void CatNthw_CfnFlush(const struct CatNthw *p);
// KCE 0/1
void CatNthw_KceSelect(const struct CatNthw *p, int index, uint32_t val);
void CatNthw_KceCnt(const struct CatNthw *p, int index, uint32_t val);
void CatNthw_KceEnable(const struct CatNthw *p, int index, uint32_t val);
void CatNthw_KceFlush(const struct CatNthw *p, int index);
// KCS 0/1
void CatNthw_KcsSelect(const struct CatNthw *p, int index, uint32_t val);
void CatNthw_KcsCnt(const struct CatNthw *p, int index, uint32_t val);
void CatNthw_KcsCategory(const struct CatNthw *p, int index, uint32_t val);
void CatNthw_KcsFlush(const struct CatNthw *p, int index);
// FTE 0/1
void CatNthw_FteSelect(const struct CatNthw *p, int index, uint32_t val);
void CatNthw_FteCnt(const struct CatNthw *p, int index, uint32_t val);
void CatNthw_FteEnable(const struct CatNthw *p, int index, uint32_t val);
void CatNthw_FteFlush(const struct CatNthw *p, int index);
// CTE
void CatNthw_CteSelect(const struct CatNthw *p, uint32_t val);
void CatNthw_CteCnt(const struct CatNthw *p, uint32_t val);
void CatNthw_CteEnableCol(const struct CatNthw *p, uint32_t val);
void CatNthw_CteEnableCor(const struct CatNthw *p, uint32_t val);
void CatNthw_CteEnableHsh(const struct CatNthw *p, uint32_t val);
void CatNthw_CteEnableQsl(const struct CatNthw *p, uint32_t val);
void CatNthw_CteEnableIpf(const struct CatNthw *p, uint32_t val);
void CatNthw_CteEnableSlc(const struct CatNthw *p, uint32_t val);
void CatNthw_CteEnablePdb(const struct CatNthw *p, uint32_t val);
void CatNthw_CteEnableMsk(const struct CatNthw *p, uint32_t val);
void CatNthw_CteEnableHst(const struct CatNthw *p, uint32_t val);
void CatNthw_CteEnableEpp(const struct CatNthw *p, uint32_t val);
void CatNthw_CteEnableTpe(const struct CatNthw *p, uint32_t val);
void CatNthw_CteEnableRrb(const struct CatNthw *p, uint32_t val);
void CatNthw_CteFlush(const struct CatNthw *p);
// CTS
void CatNthw_CtsSelect(const struct CatNthw *p, uint32_t val);
void CatNthw_CtsCnt(const struct CatNthw *p, uint32_t val);
void CatNthw_CtsFlush(const struct CatNthw *p);
void CatNthw_CtsCatA(const struct CatNthw *p, uint32_t val);
void CatNthw_CtsCatB(const struct CatNthw *p, uint32_t val);
// COT
void CatNthw_CotSelect(const struct CatNthw *p, uint32_t val);
void CatNthw_CotCnt(const struct CatNthw *p, uint32_t val);
void CatNthw_CotColor(const struct CatNthw *p, uint32_t val);
void CatNthw_CotKm(const struct CatNthw *p, uint32_t val);
void CatNthw_CotNfvSb(const struct CatNthw *p, uint32_t val);
void CatNthw_CotFlush(const struct CatNthw *p);
// CCT
void CatNthw_CctSelect(const struct CatNthw *p, uint32_t val);
void CatNthw_CctCnt(const struct CatNthw *p, uint32_t val);
void CatNthw_CctColor(const struct CatNthw *p, uint32_t val);
void CatNthw_CctKm(const struct CatNthw *p, uint32_t val);
void CatNthw_CctFlush(const struct CatNthw *p);
// EXO
void CatNthw_ExoSelect(const struct CatNthw *p, uint32_t val);
void CatNthw_ExoCnt(const struct CatNthw *p, uint32_t val);
void CatNthw_ExoDyn(const struct CatNthw *p, uint32_t val);
void CatNthw_ExoOfs(const struct CatNthw *p, int32_t val);
void CatNthw_ExoFlush(const struct CatNthw *p);
// RCK
void CatNthw_RckSelect(const struct CatNthw *p, uint32_t val);
void CatNthw_RckCnt(const struct CatNthw *p, uint32_t val);
void CatNthw_RckData(const struct CatNthw *p, uint32_t val);
void CatNthw_RckFlush(const struct CatNthw *p);
// LEN
void CatNthw_LenSelect(const struct CatNthw *p, uint32_t val);
void CatNthw_LenCnt(const struct CatNthw *p, uint32_t val);
void CatNthw_LenLower(const struct CatNthw *p, uint32_t val);
void CatNthw_LenUpper(const struct CatNthw *p, uint32_t val);
void CatNthw_LenDyn1(const struct CatNthw *p, uint32_t val);
void CatNthw_LenDyn2(const struct CatNthw *p, uint32_t val);
void CatNthw_LenInv(const struct CatNthw *p, uint32_t val);
void CatNthw_LenFlush(const struct CatNthw *p);
// KCC
void CatNthw_KccSelect(const struct CatNthw *p, uint32_t val);
void CatNthw_KccCnt(const struct CatNthw *p, uint32_t val);
void CatNthw_KccKey(const struct CatNthw *p, uint32_t *val);
void CatNthw_KccCategory(const struct CatNthw *p, uint32_t val);
void CatNthw_KccId(const struct CatNthw *p, uint32_t val);
void CatNthw_KccFlush(const struct CatNthw *p);
// CCE
void CatNthw_CceSelect(const struct CatNthw *p, uint32_t val);
void CatNthw_CceCnt(const struct CatNthw *p, uint32_t val);
void CatNthw_CceDataImm(const struct CatNthw *p, uint32_t val);
void CatNthw_CceDataInd(const struct CatNthw *p, uint32_t val);
void CatNthw_CceFlush(const struct CatNthw *p);
// CCS
void CatNthw_CcsSelect(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsCnt(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataCorEn(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataCor(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataHshEn(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataHsh(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataQslEn(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataQsl(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataIpfEn(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataIpf(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataSlcEn(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataSlc(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataPdbEn(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataPdb(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataMskEn(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataMsk(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataHstEn(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataHst(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataEppEn(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataEpp(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataTpeEn(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataTpe(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataRrbEn(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataRrb(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataSb0Type(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataSb0Data(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataSb1Type(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataSb1Data(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataSb2Type(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsDataSb2Data(const struct CatNthw *p, uint32_t val);
void CatNthw_CcsFlush(const struct CatNthw *p);


struct CatNthw {
  uint8_t mPhysicalAdapterNo;
  Fpga_t *mpFpga;
  Module_t *mCat;
  int mKmIfCnt;

  Register_t *mpCfnCtrl;
  Field_t *mpCfnAddr;
  Field_t *mpCfnCnt;
  Register_t *mpCfnData;
  Field_t *mpCfnDataEnable;
  Field_t *mpCfnDataInv;
  Field_t *mpCfnDataPtcInv;
  Field_t *mpCfnDataPtcIsl;
  Field_t *mpCfnDataPtcCfp;
  Field_t *mpCfnDataPtcMac;
  Field_t *mpCfnDataPtcL2;
  Field_t *mpCfnDataPtcVnTag;
  Field_t *mpCfnDataPtcVlan;
  Field_t *mpCfnDataPtcMpls;
  Field_t *mpCfnDataPtcL3;
  Field_t *mpCfnDataPtcFrag;
  Field_t *mpCfnDataPtcIpProt;
  Field_t *mpCfnDataPtcL4;
  Field_t *mpCfnDataPtcTunnel;
  Field_t *mpCfnDataPtcTnlL2;
  Field_t *mpCfnDataPtcTnlVlan;
  Field_t *mpCfnDataPtcTnlMpls;
  Field_t *mpCfnDataPtcTnlL3;
  Field_t *mpCfnDataPtcTnlFrag;
  Field_t *mpCfnDataPtcTnlIpProt;
  Field_t *mpCfnDataPtcTnlL4;
  Field_t *mpCfnDataErrInv;
  Field_t *mpCfnDataErrCv;
  Field_t *mpCfnDataErrFcs;
  Field_t *mpCfnDataErrTrunc;
  Field_t *mpCfnDataErrL3Cs;
  Field_t *mpCfnDataErrL4Cs;
  Field_t *mpCfnDataErrTnlL3Cs;
  Field_t *mpCfnDataErrTnlL4Cs;
  Field_t *mpCfnDataErrTtlExp;
  Field_t *mpCfnDataErrTnlTtlExp;
  Field_t *mpCfnDataMacPort;
  Field_t *mpCfnDataPmCmp;
  Field_t *mpCfnDataPmDct;
  Field_t *mpCfnDataPmExtInv;
  Field_t *mpCfnDataPmCmb;
  Field_t *mpCfnDataPmAndInv;
  Field_t *mpCfnDataPmOrInv;
  Field_t *mpCfnDataPmInv;
  Field_t *mpCfnDataLc;
  Field_t *mpCfnDataLcInv;
  Field_t *mpCfnDataKm0Or;
  Field_t *mpCfnDataKm1Or;

  Register_t *mpKceCtrl[2];
  Field_t *mpKceAddr[2];
  Field_t *mpKceCnt[2];
  Register_t *mpKceData[2];
  Field_t *mpKceDataEnable[2];

  Register_t *mpKcsCtrl[2];
  Field_t *mpKcsAddr[2];
  Field_t *mpKcsCnt[2];
  Register_t *mpKcsData[2];
  Field_t *mpKcsDataCategory[2];

  Register_t *mpFteCtrl[2];
  Field_t *mpFteAddr[2];
  Field_t *mpFteCnt[2];
  Register_t *mpFteData[2];
  Field_t *mpFteDataEnable[2];

  Register_t *mpCteCtrl;
  Field_t *mpCteAddr;
  Field_t *mpCteCnt;
  Register_t *mpCteData;
  Field_t *mpCteDataCol;
  Field_t *mpCteDataCor;
  Field_t *mpCteDataHsh;
  Field_t *mpCteDataQsl;
  Field_t *mpCteDataIpf;
  Field_t *mpCteDataSlc;
  Field_t *mpCteDataPdb;
  Field_t *mpCteDataMsk;
  Field_t *mpCteDataHst;
  Field_t *mpCteDataEpp;
  Field_t *mpCteDataTpe;
  Field_t *mpCteDataRrb;

  Register_t *mpCtsCtrl;
  Field_t *mpCtsAddr;
  Field_t *mpCtsCnt;
  Register_t *mpCtsData;
  Field_t *mpCtsDataCatA;
  Field_t *mpCtsDataCatB;

  Register_t *mpCotCtrl;
  Field_t *mpCotAddr;
  Field_t *mpCotCnt;
  Register_t *mpCotData;
  Field_t *mpCotDataColor;
  Field_t *mpCotDataKm;
  Field_t *mpCotDataNfvSb;

  Register_t *mpCctCtrl;
  Field_t *mpCctAddr;
  Field_t *mpCctCnt;
  Register_t *mpCctData;
  Field_t *mpCctDataColor;
  Field_t *mpCctDataKm;

  Register_t *mpExoCtrl;
  Field_t *mpExoAddr;
  Field_t *mpExoCnt;
  Register_t *mpExoData;
  Field_t *mpExoDataDyn;
  Field_t *mpExoDataOfs;

  Register_t *mpRckCtrl;
  Field_t *mpRckAddr;
  Field_t *mpRckCnt;
  Register_t *mpRckData;

  Register_t *mpLenCtrl;
  Field_t *mpLenAddr;
  Field_t *mpLenCnt;
  Register_t *mpLenData;
  Field_t *mpLenDataLower;
  Field_t *mpLenDataUpper;
  Field_t *mpLenDataDyn1;
  Field_t *mpLenDataDyn2;
  Field_t *mpLenDataInv;
  Register_t *mpKccCtrl;
  Field_t *mpKccAddr;
  Field_t *mpKccCnt;

  Register_t *mpKccData;
  Field_t *mpKccDataKey;
  Field_t *mpKccDataCategory;
  Field_t *mpKccDataId;

  Register_t *mpCceCtrl;
  Field_t *mpCceAddr;
  Field_t *mpCceCnt;

  Register_t *mpCceData;
  Field_t *mpCceDataImm;
  Field_t *mpCceDataInd;

  Register_t *mpCcsCtrl;
  Field_t *mpCcsAddr;
  Field_t *mpCcsCnt;

  Register_t *mpCcsData;
  Field_t *mpCcsDataCorEn;
  Field_t *mpCcsDataCor;

  Field_t *mpCcsDataHshEn;
  Field_t *mpCcsDataHsh;
  Field_t *mpCcsDataQslEn;
  Field_t *mpCcsDataQsl;
  Field_t *mpCcsDataIpfEn;
  Field_t *mpCcsDataIpf;
  Field_t *mpCcsDataSlcEn;
  Field_t *mpCcsDataSlc;
  Field_t *mpCcsDataPdbEn;
  Field_t *mpCcsDataPdb;
  Field_t *mpCcsDataMskEn;
  Field_t *mpCcsDataMsk;
  Field_t *mpCcsDataHstEn;
  Field_t *mpCcsDataHst;
  Field_t *mpCcsDataEppEn;
  Field_t *mpCcsDataEpp;
  Field_t *mpCcsDataTpeEn;
  Field_t *mpCcsDataTpe;
  Field_t *mpCcsDataRrbEn;
  Field_t *mpCcsDataRrb;
  Field_t *mpCcsDataSb0Type;
  Field_t *mpCcsDataSb0Data;
  Field_t *mpCcsDataSb1Type;
  Field_t *mpCcsDataSb1Data;
  Field_t *mpCcsDataSb2Type;
  Field_t *mpCcsDataSb2Data;
};

#endif // __FLOW_NTHW_CAT_H__

//
// EOF
//
