#ifndef _FLOW_NTHW_CSU_H_
#define _FLOW_NTHW_CSU_H_

#include <stdint.h>
#include "nthw_fpga_model.h"

struct CsuNthw {
  uint8_t mPhysicalAdapterNo;
  Fpga_t *mpFpga;

  Module_t *mCsu;

  Register_t *mpRcpCtrl;
  Field_t *mpRcpCtrlAdr;
  Field_t *mpRcpCtrlCnt;
  Register_t *mpRcpData;
  Field_t *mpRcpDataOl3Cmd;
  Field_t *mpRcpDataOl4Cmd;
  Field_t *mpRcpDataIl3Cmd;
  Field_t *mpRcpDataIl4Cmd;
};

//
//
//
struct CsuNthw *CsuNthw_new(void);
void CsuNthw_delete(struct CsuNthw *p);
int CsuNthw_init(struct CsuNthw *p, Fpga_t *pFpga, int nInstance);
//
int CsuNthw_setup(struct CsuNthw *p, int nIdx, int nIdxCnt);
void csuNthw_setDebugMode(struct CsuNthw *p, unsigned nDebugMode);
//

#if 0
  uint32_t GetVersionMajor(void) {return (mCsu.getVersion()).getMajorVersion();}
  uint32_t GetVersionMinor(void) {return (mCsu.getVersion()).getMinorVersion();}
  void SetDebugOutput(int on) {if (on) mCsu.setDebugMode(Register::ON_WRITE); else mCsu.setDebugMode(Register::NO_DEBUG);}
#endif

void CsuNthw_RcpSelect(const struct CsuNthw *p, uint32_t val);
void CsuNthw_RcpCnt(const struct CsuNthw *p, uint32_t val);
void CsuNthw_RcpOuterL3Cmd(const struct CsuNthw *p, uint32_t val);
void CsuNthw_RcpOuterL4Cmd(const struct CsuNthw *p, uint32_t val);
void CsuNthw_RcpInnerL3Cmd(const struct CsuNthw *p, uint32_t val);
void CsuNthw_RcpInnerL4Cmd(const struct CsuNthw *p, uint32_t val);
void CsuNthw_RcpFlush(const struct CsuNthw *p);

#endif //_FLOW_NTHW_CSU_H_
