#ifndef __FLOW_NTHW_FLM_H__
#define __FLOW_NTHW_FLM_H__

#include <stdint.h> // uint32_t
#include "nthw_fpga_model.h"

struct FlmNthw;

typedef struct FlmNthw FlmNthw_t;

//
//
//
struct FlmNthw *FlmNthw_new(void);
void FlmNthw_delete(struct FlmNthw *p);
int FlmNthw_init(struct FlmNthw *p, Fpga_t *pFpga, int nInstance);
//
// int FlmNthw_setup(struct FlmNthw *p, int nIdx, int nIdxCnt);
void flmNthw_setDebugMode(struct FlmNthw *p, unsigned nDebugMode);
//

#if 0
uint32_t GetVersionMajor(void) {return (mFlm.getVersion()).getMajorVersion();}
uint32_t GetVersionMinor(void) {return (mFlm.getVersion()).getMinorVersion();}
void SetDebugOutput(int on) {if (on) mFlm.setDebugMode(Register::ON_WRITE); else mFlm.setDebugMode(Register::NO_DEBUG);}
#endif

// Control
void FlmNthw_ControlEnable(const struct FlmNthw *p, uint32_t val);
void FlmNthw_ControlInit(const struct FlmNthw *p, uint32_t val);
void FlmNthw_ControlLds(const struct FlmNthw *p, uint32_t val);
void FlmNthw_ControlLfs(const struct FlmNthw *p, uint32_t val);
void FlmNthw_ControlLis(const struct FlmNthw *p, uint32_t val);
void FlmNthw_ControlUds(const struct FlmNthw *p, uint32_t val);
void FlmNthw_ControlUis(const struct FlmNthw *p, uint32_t val);
void FlmNthw_ControlRds(const struct FlmNthw *p, uint32_t val);
void FlmNthw_ControlRis(const struct FlmNthw *p, uint32_t val);
void FlmNthw_ControlPds(const struct FlmNthw *p, uint32_t val);
void FlmNthw_ControlPis(const struct FlmNthw *p, uint32_t val);
void FlmNthw_ControlCrcwr(const struct FlmNthw *p, uint32_t val);
void FlmNthw_ControlCrcrd(const struct FlmNthw *p, uint32_t val);
void FlmNthw_ControlRbl(const struct FlmNthw *p, uint32_t val);
void FlmNthw_ControlEab(const struct FlmNthw *p, uint32_t val);
void FlmNthw_ControlSplitSdramUsage(const struct FlmNthw *p, uint32_t val);
void FlmNthw_ControlFlush(const struct FlmNthw *p);

// Status
void FlmNthw_StatusCalibdone(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatusInitdone(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatusIdle(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatusCritical(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatusPanic(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatusCrcerr(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatusEftBp(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatusFlush(const struct FlmNthw *p);
void FlmNthw_StatusUpdate(const struct FlmNthw *p);

// Timeout
void FlmNthw_TimeoutT(const struct FlmNthw *p, uint32_t val);
void FlmNthw_TimeoutFlush(const struct FlmNthw *p);

// Scrub
void FlmNthw_ScrubI(const struct FlmNthw *p, uint32_t val);
void FlmNthw_ScrubFlush(const struct FlmNthw *p);

// Load BIN
void FlmNthw_LoadBin(const struct FlmNthw *p, uint32_t val);
void FlmNthw_LoadBinFlush(const struct FlmNthw *p);

// Load PPS
void FlmNthw_LoadPps(const struct FlmNthw *p, uint32_t val);
void FlmNthw_LoadPpsFlush(const struct FlmNthw *p);

// Load LPS
void FlmNthw_LoadLps(const struct FlmNthw *p, uint32_t val);
void FlmNthw_LoadLpsFlush(const struct FlmNthw *p);

// Load APS
void FlmNthw_LoadAps(const struct FlmNthw *p, uint32_t val);
void FlmNthw_LoadApsFlush(const struct FlmNthw *p);

// Prio
void FlmNthw_PrioLimit0(const struct FlmNthw *p, uint32_t val);
void FlmNthw_PrioFt0(const struct FlmNthw *p, uint32_t val);
void FlmNthw_PrioLimit1(const struct FlmNthw *p, uint32_t val);
void FlmNthw_PrioFt1(const struct FlmNthw *p, uint32_t val);
void FlmNthw_PrioLimit2(const struct FlmNthw *p, uint32_t val);
void FlmNthw_PrioFt2(const struct FlmNthw *p, uint32_t val);
void FlmNthw_PrioLimit3(const struct FlmNthw *p, uint32_t val);
void FlmNthw_PrioFt3(const struct FlmNthw *p, uint32_t val);
void FlmNthw_PrioFlush(const struct FlmNthw *p);

// PST
void FlmNthw_PstSelect(const struct FlmNthw *p, uint32_t val);
void FlmNthw_PstCnt(const struct FlmNthw *p, uint32_t val);
void FlmNthw_PstBp(const struct FlmNthw *p, uint32_t val);
void FlmNthw_PstPp(const struct FlmNthw *p, uint32_t val);
void FlmNthw_PstTp(const struct FlmNthw *p, uint32_t val);
void FlmNthw_PstFlush(const struct FlmNthw *p);

// RCP
void FlmNthw_RcpSelect(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpCnt(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpLookup(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpQw0Dyn(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpQw0Ofs(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpQw0Sel(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpQw4Dyn(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpQw4Ofs(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpSw8Dyn(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpSw8Ofs(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpSw8Sel(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpSw9Dyn(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpSw9Ofs(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpMask(const struct FlmNthw *p, const uint32_t *val);
void FlmNthw_RcpKid(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpOpn(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpIpn(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpBytDyn(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpBytOfs(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpTxplm(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpAutoIpv4Mask(const struct FlmNthw *p, uint32_t val);
void FlmNthw_RcpFlush(const struct FlmNthw *p);

// Buf Ctrl
int FlmNthw_BufCtrlUpdate(const struct FlmNthw *p, uint32_t* lrn_free, uint32_t* inf_avail, uint32_t* sta_avail);

// Lrn Data
int FlmNthw_LrnDataFlush(const struct FlmNthw *p, const uint32_t *data, uint32_t wordCount, uint32_t* lrn_free, uint32_t* inf_avail, uint32_t* sta_avail);

// Inf Data
int FlmNthw_InfDataUpdate(const struct FlmNthw *p, uint32_t *data, uint32_t wordCount, uint32_t* lrn_free, uint32_t* inf_avail, uint32_t* sta_avail);

// Sta Data
int FlmNthw_StaDataUpdate(const struct FlmNthw *p, uint32_t *data, uint32_t wordCount, uint32_t* lrn_free, uint32_t* inf_avail, uint32_t* sta_avail);

// Stat Lrn Done
void FlmNthw_StatLrnDoneCnt(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatLrnDoneUpdate(const struct FlmNthw *p);

// Stat Lrn Ignore
void FlmNthw_StatLrnIgnoreCnt(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatLrnIgnoreUpdate(const struct FlmNthw *p);

// Stat Lrn Fail
void FlmNthw_StatLrnFailCnt(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatLrnFailUpdate(const struct FlmNthw *p);

// Stat Unl Done
void FlmNthw_StatUnlDoneCnt(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatUnlDoneUpdate(const struct FlmNthw *p);

// Stat Unl Ignore
void FlmNthw_StatUnlIgnoreCnt(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatUnlIgnoreUpdate(const struct FlmNthw *p);

// Stat Prb Done
void FlmNthw_StatPrbDoneCnt(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatPrbDoneUpdate(const struct FlmNthw *p);

// Stat Prb Ignore
void FlmNthw_StatPrbIgnoreCnt(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatPrbIgnoreUpdate(const struct FlmNthw *p);

// Stat Rel Done
void FlmNthw_StatRelDoneCnt(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatRelDoneUpdate(const struct FlmNthw *p);

// Stat Rel Ignore
void FlmNthw_StatRelIgnoreCnt(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatRelIgnoreUpdate(const struct FlmNthw *p);

// Stat Aul Done
void FlmNthw_StatAulDoneCnt(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatAulDoneUpdate(const struct FlmNthw *p);

// Stat Aul Ignore
void FlmNthw_StatAulIgnoreCnt(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatAulIgnoreUpdate(const struct FlmNthw *p);

// Stat Aul Fail
void FlmNthw_StatAulFailCnt(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatAulFailUpdate(const struct FlmNthw *p);

// Stat Tul Done
void FlmNthw_StatTulDoneCnt(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatTulDoneUpdate(const struct FlmNthw *p);

// Stat Flows
void FlmNthw_StatFlowsCnt(const struct FlmNthw *p, uint32_t *val, int get);
void FlmNthw_StatFlowsUpdate(const struct FlmNthw *p);


struct FlmNthw {
  uint8_t mPhysicalAdapterNo;
  Fpga_t *mpFpga;
  void   *mpRac;

  Module_t *mFlm;

  Register_t *mpControl;
  Field_t *mpControlEnable;
  Field_t *mpControlInit;
  Field_t *mpControlLds;
  Field_t *mpControlLfs;
  Field_t *mpControlLis;
  Field_t *mpControlUds;
  Field_t *mpControlUis;
  Field_t *mpControlRds;
  Field_t *mpControlRis;
  Field_t *mpControlPds;
  Field_t *mpControlPis;
  Field_t *mpControlCrcwr;
  Field_t *mpControlCrcrd;
  Field_t *mpControlRbl;
  Field_t *mpControlEab;
  Field_t *mpControlSplitSdramUsage;

  Register_t *mpStatus;
  Field_t *mpStatusCalibdone;
  Field_t *mpStatusInitdone;
  Field_t *mpStatusIdle;
  Field_t *mpStatusCritical;
  Field_t *mpStatusPanic;
  Field_t *mpStatusCrcerr;
  Field_t *mpStatusEftBp;

  Register_t *mpTimeout;
  Field_t *mpTimeoutT;

  Register_t *mpScrub;
  Field_t *mpScrubI;

  Register_t *mpLoadBin;
  Field_t *mpLoadBinBin;

  Register_t *mpLoadPps;
  Field_t *mpLoadPpsPps;

  Register_t *mpLoadLps;
  Field_t *mpLoadLpsLps;

  Register_t *mpLoadAps;
  Field_t *mpLoadApsAps;

  Register_t *mpPrio;
  Field_t *mpPrioLimit0;
  Field_t *mpPrioFt0;
  Field_t *mpPrioLimit1;
  Field_t *mpPrioFt1;
  Field_t *mpPrioLimit2;
  Field_t *mpPrioFt2;
  Field_t *mpPrioLimit3;
  Field_t *mpPrioFt3;

  Register_t *mpPstCtrl;
  Field_t *mpPstCtrlAdr;
  Field_t *mpPstCtrlCnt;
  Register_t *mpPstData;
  Field_t *mpPstDataBp;
  Field_t *mpPstDataPp;
  Field_t *mpPstDataTp;

  Register_t *mpRcpCtrl;
  Field_t *mpRcpCtrlAdr;
  Field_t *mpRcpCtrlCnt;
  Register_t *mpRcpData;
  Field_t *mpRcpDataLookup;
  Field_t *mpRcpDataQw0Dyn;
  Field_t *mpRcpDataQw0Ofs;
  Field_t *mpRcpDataQw0Sel;
  Field_t *mpRcpDataQw4Dyn;
  Field_t *mpRcpDataQw4Ofs;
  Field_t *mpRcpDataSw8Dyn;
  Field_t *mpRcpDataSw8Ofs;
  Field_t *mpRcpDataSw8Sel;
  Field_t *mpRcpDataSw9Dyn;
  Field_t *mpRcpDataSw9Ofs;
  Field_t *mpRcpDataMask;
  Field_t *mpRcpDataKid;
  Field_t *mpRcpDataOpn;
  Field_t *mpRcpDataIpn;
  Field_t *mpRcpDataBytDyn;
  Field_t *mpRcpDataBytOfs;
  Field_t *mpRcpDataTxplm;
  Field_t *mpRcpDataAutoIpv4Mask;

  Register_t *mpBufCtrl;
  Field_t *mpBufCtrlLrnFree;
  Field_t *mpBufCtrlInfAvail;
  Field_t *mpBufCtrlStaAvail;

  Register_t *mpLrnData;
  Register_t *mpInfData;
  Register_t *mpStaData;

  Register_t *mpStatLrnDone;
  Field_t *mpStatLrnDoneCnt;

  Register_t *mpStatLrnIgnore;
  Field_t *mpStatLrnIgnoreCnt;

  Register_t *mpStatLrnFail;
  Field_t *mpStatLrnFailCnt;

  Register_t *mpStatUnlDone;
  Field_t *mpStatUnlDoneCnt;

  Register_t *mpStatUnlIgnore;
  Field_t *mpStatUnlIgnoreCnt;

  Register_t *mpStatPrbDone;
  Field_t *mpStatPrbDoneCnt;

  Register_t *mpStatPrbIgnore;
  Field_t *mpStatPrbIgnoreCnt;

  Register_t *mpStatRelDone;
  Field_t *mpStatRelDoneCnt;

  Register_t *mpStatRelIgnore;
  Field_t *mpStatRelIgnoreCnt;

  Register_t *mpStatAulDone;
  Field_t *mpStatAulDoneCnt;

  Register_t *mpStatAulIgnore;
  Field_t *mpStatAulIgnoreCnt;

  Register_t *mpStatAulFail;
  Field_t *mpStatAulFailCnt;

  Register_t *mpStatTulDone;
  Field_t *mpStatTulDoneCnt;

  Register_t *mpStatFlows;
  Field_t *mpStatFlowsCnt;

};

#endif //__FLOW_NTHW_FLM_H__
