#ifndef __FLOW_NTHW_HFU_H__
#define __FLOW_NTHW_HFU_H__

#include <stdint.h>
#include "nthw_fpga_model.h"

struct HfuNthw {
  uint8_t mPhysicalAdapterNo;
  Fpga_t *mpFpga;

  Module_t *mHfu;

  Register_t *mpRcpCtrl;
  Field_t *mpRcpAddr;
  Field_t *mpRcpCnt;

  Register_t *mpRcpData;
  Field_t *mpRcpDataLenAWr;
  Field_t *mpRcpDataLenAOl4len;
  Field_t *mpRcpDataLenAPosDyn;
  Field_t *mpRcpDataLenAPosOfs;
  Field_t *mpRcpDataLenAAddDyn;
  Field_t *mpRcpDataLenAAddOfs;
  Field_t *mpRcpDataLenASubDyn;
  Field_t *mpRcpDataLenBWr;
  Field_t *mpRcpDataLenBPosDyn;
  Field_t *mpRcpDataLenBPosOfs;
  Field_t *mpRcpDataLenBAddDyn;
  Field_t *mpRcpDataLenBAddOfs;
  Field_t *mpRcpDataLenBSubDyn;
  Field_t *mpRcpDataLenCWr;
  Field_t *mpRcpDataLenCPosDyn;
  Field_t *mpRcpDataLenCPosOfs;
  Field_t *mpRcpDataLenCAddDyn;
  Field_t *mpRcpDataLenCAddOfs;
  Field_t *mpRcpDataLenCSubDyn;
  Field_t *mpRcpDataTtlWr;
  Field_t *mpRcpDataTtlPosDyn;
  Field_t *mpRcpDataTtlPosOfs;
  Field_t *mpRcpDataCsinf;
  Field_t *mpRcpDataL3prt;
  Field_t *mpRcpDataL3frag;
  Field_t *mpRcpDataTunnel;
  Field_t *mpRcpDataL4prt;
  Field_t *mpRcpDataOl3ofs;
  Field_t *mpRcpDataOl4ofs;
  Field_t *mpRcpDataIl3ofs;
  Field_t *mpRcpDataIl4ofs;
};

//
//
//
struct HfuNthw *HfuNthw_new(void);
void HfuNthw_delete(struct HfuNthw *p);
int HfuNthw_init(struct HfuNthw *p, Fpga_t *pFpga, int nInstance);
//
int HfuNthw_setup(struct HfuNthw *p, int nIdx, int nIdxCnt);
void hfuNthw_setDebugMode(struct HfuNthw *p, unsigned nDebugMode);
//

#if 0
  uint32_t GetVersionMajor(void) {return (mHfu.getVersion()).getMajorVersion();}
  uint32_t GetVersionMinor(void) {return (mHfu.getVersion()).getMinorVersion();}
  void SetDebugOutput(int on) {if (on) mHfu.setDebugMode(Register::ON_WRITE); else mHfu.setDebugMode(Register::NO_DEBUG);}
#endif

// RCP
void HfuNthw_RcpSelect(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpCnt(const struct HfuNthw *p, uint32_t val);

void HfuNthw_RcpLenAWr(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenAOl4len(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenAPosDyn(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenAPosOfs(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenAAddDyn(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenAAddOfs(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenASubDyn(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenBWr(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenBPosDyn(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenBPosOfs(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenBAddDyn(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenBAddOfs(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenBSubDyn(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenCWr(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenCPosDyn(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenCPosOfs(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenCAddDyn(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenCAddOfs(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpLenCSubDyn(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpTtlWr(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpTtlPosDyn(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpTtlPosOfs(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpCsinf(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpL3prt(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpL3frag(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpTunnel(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpL4prt(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpOl3ofs(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpOl4ofs(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpIl3ofs(const struct HfuNthw *p, uint32_t val);
void HfuNthw_RcpIl4ofs(const struct HfuNthw *p, uint32_t val);

void HfuNthw_RcpFlush(const struct HfuNthw *p);

#endif //__FLOW_NTHW_HFU_H__
