#ifndef __FLOW_NTHW_HSH_H__
#define __FLOW_NTHW_HSH_H__

#include <stdint.h> // uint32_t
#include "nthw_fpga_model.h"

struct HshNthw;

typedef struct HshNthw HshNthw_t;
//typedef struct HshNthw HshNthw;

//
//
//
struct HshNthw *HshNthw_new(void);
void HshNthw_delete(struct HshNthw *p);
int HshNthw_init(struct HshNthw *p, Fpga_t *pFpga, int nInstance);
//
int HshNthw_setup(struct HshNthw *p, int nIdx, int nIdxCnt);
void hshNthw_setDebugMode(struct HshNthw *p, unsigned nDebugMode);
//

#if 0
uint32_t GetVersionMajor(void) {return (mHsh.getVersion()).getMajorVersion();}
uint32_t GetVersionMinor(void) {return (mHsh.getVersion()).getMinorVersion();}
void SetDebugOutput(int on) {if (on) mHsh.setDebugMode(Register::ON_WRITE); else mHsh.setDebugMode(Register::NO_DEBUG);}
#endif

// RCP
void HshNthw_RcpSelect(const struct HshNthw *p, uint32_t val);
void HshNthw_RcpCnt(const struct HshNthw *p, uint32_t val);
void HshNthw_RcpLoadDistType(const struct HshNthw *p, uint32_t val);
void HshNthw_RcpMacPortMask(const struct HshNthw *p, uint32_t *val);
void HshNthw_RcpSort(const struct HshNthw *p, uint32_t val);
void HshNthw_RcpQw0Pe(const struct HshNthw *p, uint32_t val);
void HshNthw_RcpQw0Ofs(const struct HshNthw *p, int32_t val);
void HshNthw_RcpQw4Pe(const struct HshNthw *p, uint32_t val);
void HshNthw_RcpQw4Ofs(const struct HshNthw *p, int32_t val);
void HshNthw_RcpW8Pe(const struct HshNthw *p, uint32_t val);
void HshNthw_RcpW8Ofs(const struct HshNthw *p, int32_t val);
void HshNthw_RcpW8Sort(const struct HshNthw *p, uint32_t val);
void HshNthw_RcpW9Pe(const struct HshNthw *p, uint32_t val);
void HshNthw_RcpW9Ofs(const struct HshNthw *p, int32_t val);
void HshNthw_RcpW9Sort(const struct HshNthw *p, uint32_t val);
void HshNthw_RcpW9P(const struct HshNthw *p, uint32_t val);
void HshNthw_RcpPMask(const struct HshNthw *p, uint32_t val);
void HshNthw_RcpWordMask(const struct HshNthw *p, uint32_t *val);
void HshNthw_RcpSeed(const struct HshNthw *p, uint32_t val);
void HshNthw_RcpTnlP(const struct HshNthw *p, uint32_t val);
void HshNthw_RcpHshValid(const struct HshNthw *p, uint32_t val);
void HshNthw_RcpHshType(const struct HshNthw *p, uint32_t val);
void HshNthw_RcpAutoIpv4Mask(const struct HshNthw *p, uint32_t val);
void HshNthw_RcpFlush(const struct HshNthw *p);

struct HshNthw {
  uint8_t mPhysicalAdapterNo;
  Fpga_t *mpFpga;

  Module_t *mHsh;

  Register *mpRcpCtrl;
  Field_t *mpRcpAddr;
  Field_t *mpRcpCnt;
  Register *mpRcpData;
  Field_t *mpRcpDataLoadDistType;
  Field_t *mpRcpDataMacPortMask;
  Field_t *mpRcpDataSort;
  Field_t *mpRcpDataQw0Pe;
  Field_t *mpRcpDataQw0Ofs;
  Field_t *mpRcpDataQw4Pe;
  Field_t *mpRcpDataQw4Ofs;
  Field_t *mpRcpDataW8Pe;
  Field_t *mpRcpDataW8Ofs;
  Field_t *mpRcpDataW8Sort;
  Field_t *mpRcpDataW9Pe;
  Field_t *mpRcpDataW9Ofs;
  Field_t *mpRcpDataW9Sort;
  Field_t *mpRcpDataW9P;
  Field_t *mpRcpDataPMask;
  Field_t *mpRcpDataWordMask;
  Field_t *mpRcpDataSeed;
  Field_t *mpRcpDataTnlP;
  Field_t *mpRcpDataHshValid;
  Field_t *mpRcpDataHshType;
  Field_t *mpRcpDataAutoIpv4Mask;
};

#endif //__FLOW_NTHW_HSH_H__
