#ifndef __FLOW_NTHW_INFO_H__
#define __FLOW_NTHW_INFO_H__

#include <stdint.h> // uint32_t
#include "nthw_fpga_model.h"

struct InfoNthw;

//
//
//
struct InfoNthw *InfoNthw_new(void);
void InfoNthw_delete(struct InfoNthw *p);
int InfoNthw_init(struct InfoNthw *p, Fpga_t *pFpga, int nInstance);
//
int InfoNthw_setup(struct InfoNthw *p, int nIdx, int nIdxCnt);
//

unsigned InfoNthw_getNbPhyPorts(const struct InfoNthw *p);
unsigned InfoNthw_getNbRxPorts(const struct InfoNthw *p);
unsigned InfoNthw_getLtxAvail(const struct InfoNthw *p);

unsigned InfoNthw_getNbCategories(const struct InfoNthw *p);
unsigned InfoNthw_getNbQueues(const struct InfoNthw *p);
unsigned InfoNthw_getNbCatFuncs(const struct InfoNthw *p);
unsigned InfoNthw_getNbKMFlowTypes(const struct InfoNthw *p);
unsigned InfoNthw_getNbPmExt(const struct InfoNthw *p);
unsigned InfoNthw_getNbLen(const struct InfoNthw *p);
unsigned InfoNthw_getKccSize(const struct InfoNthw *p);
unsigned InfoNthw_getKccBanks(const struct InfoNthw *p);
unsigned InfoNthw_getNbKmCategories(const struct InfoNthw *p);
unsigned InfoNthw_getNbKmCamBanks(const struct InfoNthw *p);
unsigned InfoNthw_getNbKmCamRecordWords(const struct InfoNthw *p);
unsigned InfoNthw_getNbKmCamRecords(const struct InfoNthw *p);
unsigned InfoNthw_getNbKmTcamBanks(const struct InfoNthw *p);
unsigned InfoNthw_getNbKmTcamBankWidth(const struct InfoNthw *p);
unsigned InfoNthw_getNbFlmCategories(const struct InfoNthw *p);
unsigned InfoNthw_getNbFlmSizeMb(const struct InfoNthw *p);
unsigned InfoNthw_getNbFlmEntrySize(const struct InfoNthw *p);
unsigned InfoNthw_getNbFlmVariant(const struct InfoNthw *p);
unsigned InfoNthw_getNbFlmPrios(const struct InfoNthw *p);
unsigned InfoNthw_getNbFlmPstProfiles(const struct InfoNthw *p);
unsigned InfoNthw_getNbHstCategories(const struct InfoNthw *p);
unsigned InfoNthw_getNbQslCategories(const struct InfoNthw *p);
unsigned InfoNthw_getNbQslQstEntries(const struct InfoNthw *p);
unsigned InfoNthw_getNbPdbCategories(const struct InfoNthw *p);
unsigned InfoNthw_getNbIoaCategories(const struct InfoNthw *p);
unsigned InfoNthw_getNbRoaCategories(const struct InfoNthw *p);
unsigned InfoNthw_getNbDbsCategories(const struct InfoNthw *p);
unsigned InfoNthw_getNbCatKmIfCnt(const struct InfoNthw *p);
unsigned InfoNthw_getNbCatKmIfM0(const struct InfoNthw *p);
unsigned InfoNthw_getNbCatKmIfM1(const struct InfoNthw *p);
unsigned InfoNthw_getNbTpeCategories(const struct InfoNthw *p);
unsigned InfoNthw_getNbTxCpyWriters(const struct InfoNthw *p);
unsigned InfoNthw_getNbTxCpyMaskMem(const struct InfoNthw *p);
unsigned InfoNthw_getNbTxRplDepth(const struct InfoNthw *p);
unsigned InfoNthw_getNbTxRplExtCategories(const struct InfoNthw *p);

struct InfoNthw {
  uint8_t mPhysicalAdapterNo;
  Fpga_t *mpFpga;
  unsigned nPhyPorts;
  unsigned nRxPorts;
  unsigned nLtxAvail;
  unsigned nbCatFunc;
  unsigned nbCategories;
  unsigned nbQueues;
  unsigned nbFlowTypes;
  unsigned nbPmExt;
  unsigned nbLen;
  unsigned nbKccSize;
  unsigned nbKccBanks;
  unsigned nbKmCategories;
  unsigned nbKmCamBanks;
  unsigned nbKmCamRecordWords;
  unsigned nbKmCamRecords;
  unsigned nbKmTcamBanks;
  unsigned nbKmTcamBankWidth;
  unsigned nbFlmCategories;
  unsigned nbFlmSizeMb;
  unsigned nbFlmEntrySize;
  unsigned nbFlmVariant;
  unsigned nbFlmPrios;
  unsigned nbFlmPstProfiles;
  unsigned nbHstCategories;
  unsigned nbQslCategories;
  unsigned nbQslQstEntries;
  unsigned nbPdbCategories;
  unsigned nbIoaCategories;
  unsigned nbRoaCategories;
  unsigned nbDbsCategories;
  unsigned nbCatKmIfCnt;
  unsigned mCatKmIfM0;
  unsigned mCatKmIfM1;
  unsigned nbTpeCategories;
  unsigned nbTxCpyWriters;
  unsigned nbTxCpyMaskMem;
  unsigned nbTxRplDepth;
  unsigned nbTxRplExtCategories;
};

#endif  //__FLOW_NTHW_INFO_H__
