#ifndef __FLOW_NTHW_KM_H__
#define __FLOW_NTHW_KM_H__

#include <stdint.h> // uint32_t
#include "nthw_fpga_model.h"

struct KmNthw;

typedef struct KmNthw KmNthw_t;
// typedef struct KmNthw KmNthw;

//
//
//
struct KmNthw *KmNthw_new(void);
void KmNthw_delete(struct KmNthw *p);
int KmNthw_init(struct KmNthw *p, Fpga_t *pFpga, int nInstance);
//
int KmNthw_setup(struct KmNthw *p, int nIdx, int nIdxCnt);
void kmNthw_setDebugMode(struct KmNthw *p, unsigned nDebugMode);
//

#if 0
uint32_t GetVersionMajor(void) {return (mKm.getVersion()).getMajorVersion();}
uint32_t GetVersionMinor(void) {return (mKm.getVersion()).getMinorVersion();}
void SetDebugOutput(int on) {if (on) mKm.setDebugMode(Register::ON_WRITE); else mKm.setDebugMode(Register::NO_DEBUG);}
#endif

  // RCP initial v3
  void KmNthw_RcpSelect(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpCnt(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpQw0Dyn(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpQw0Ofs(const struct KmNthw *p, int32_t val);
  void KmNthw_RcpQw0SelA(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpQw0SelB(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpQw4Dyn(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpQw4Ofs(const struct KmNthw *p, int32_t val);
  void KmNthw_RcpQw4SelA(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpQw4SelB(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpSw8Dyn(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpSw8Ofs(const struct KmNthw *p, int32_t val);
  void KmNthw_RcpSw8SelA(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpSw8SelB(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpSw9Dyn(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpSw9Ofs(const struct KmNthw *p, int32_t val);
  void KmNthw_RcpSw9SelA(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpSw9SelB(const struct KmNthw *p, uint32_t val);
  // subst in v6
  void KmNthw_RcpDw8Dyn(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpDw8Ofs(const struct KmNthw *p, int32_t val);
  void KmNthw_RcpDw8SelA(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpDw8SelB(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpDw10Dyn(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpDw10Ofs(const struct KmNthw *p, int32_t val);
  void KmNthw_RcpDw10SelA(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpDw10SelB(const struct KmNthw *p, uint32_t val);

  void KmNthw_RcpSwxOvsSb(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpSwxCch(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpSwxSelA(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpSwxSelB(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpMaskA(const struct KmNthw *p, const uint32_t *val);
  void KmNthw_RcpMaskDA(const struct KmNthw *p, const uint32_t *val);
  void KmNthw_RcpMaskB(const struct KmNthw *p, const uint32_t *val);
  void KmNthw_RcpDual(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpPaired(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpElA(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpElB(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpInfoA(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpInfoB(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpFtmA(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpFtmB(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpBankA(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpBankB(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpKlA(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpKlB(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpFlowSet(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpKeywayA(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpKeywayB(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpSynergyMode(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpDw0BDyn(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpDw0BOfs(const struct KmNthw *p, int32_t val);
  void KmNthw_RcpDw2BDyn(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpDw2BOfs(const struct KmNthw *p, int32_t val);
  void KmNthw_RcpSw4BDyn(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpSw4BOfs(const struct KmNthw *p, int32_t val);
  void KmNthw_RcpSw5BDyn(const struct KmNthw *p, uint32_t val);
  void KmNthw_RcpSw5BOfs(const struct KmNthw *p, int32_t val);
  void KmNthw_RcpFlush(const struct KmNthw *p);
  // CAM
  void KmNthw_CamSelect(const struct KmNthw *p, uint32_t val);
  void KmNthw_CamCnt(const struct KmNthw *p, uint32_t val);
  void KmNthw_CamW0(const struct KmNthw *p, uint32_t val);
  void KmNthw_CamW1(const struct KmNthw *p, uint32_t val);
  void KmNthw_CamW2(const struct KmNthw *p, uint32_t val);
  void KmNthw_CamW3(const struct KmNthw *p, uint32_t val);
  void KmNthw_CamW4(const struct KmNthw *p, uint32_t val);
  void KmNthw_CamW5(const struct KmNthw *p, uint32_t val);
  void KmNthw_CamFt0(const struct KmNthw *p, uint32_t val);
  void KmNthw_CamFt1(const struct KmNthw *p, uint32_t val);
  void KmNthw_CamFt2(const struct KmNthw *p, uint32_t val);
  void KmNthw_CamFt3(const struct KmNthw *p, uint32_t val);
  void KmNthw_CamFt4(const struct KmNthw *p, uint32_t val);
  void KmNthw_CamFt5(const struct KmNthw *p, uint32_t val);
  void KmNthw_CamFlush(const struct KmNthw *p);
  // TCAM
  void KmNthw_TcamSelect(const struct KmNthw *p, uint32_t val);
  void KmNthw_TcamCnt(const struct KmNthw *p, uint32_t val);
  void KmNthw_TcamT(const struct KmNthw *p, uint32_t *val);
  void KmNthw_TcamFlush(const struct KmNthw *p);
  // TCI
  void KmNthw_TciSelect(const struct KmNthw *p, uint32_t val);
  void KmNthw_TciCnt(const struct KmNthw *p, uint32_t val);
  void KmNthw_TciColor(const struct KmNthw *p, uint32_t val);
  void KmNthw_TciFt(const struct KmNthw *p, uint32_t val);
  void KmNthw_TciFlush(const struct KmNthw *p);
  // TCQ
  void KmNthw_TcqSelect(const struct KmNthw *p, uint32_t val);
  void KmNthw_TcqCnt(const struct KmNthw *p, uint32_t val);
  void KmNthw_TcqBankMask(const struct KmNthw *p, uint32_t val);
  void KmNthw_TcqQual(const struct KmNthw *p, uint32_t val);
  void KmNthw_TcqQual72(const struct KmNthw *p, uint32_t *val);

  void KmNthw_TcqFlush(const struct KmNthw *p);

struct KmNthw {
  uint8_t mPhysicalAdapterNo;
  Fpga_t *mpFpga;

  Module_t *mKm;

  Register_t *mpRcpCtrl;
  Field_t *mpRcpAddr;
  Field_t *mpRcpCnt;
  Register_t *mpRcpData;
  Field_t *mpRcpDataQw0Dyn;
  Field_t *mpRcpDataQw0Ofs;
  Field_t *mpRcpDataQw0SelA;
  Field_t *mpRcpDataQw0SelB;
  Field_t *mpRcpDataQw4Dyn;
  Field_t *mpRcpDataQw4Ofs;
  Field_t *mpRcpDataQw4SelA;
  Field_t *mpRcpDataQw4SelB;
  Field_t *mpRcpDataSw8Dyn;
  Field_t *mpRcpDataSw8Ofs;
  Field_t *mpRcpDataSw8SelA;
  Field_t *mpRcpDataSw8SelB;
  Field_t *mpRcpDataSw9Dyn;
  Field_t *mpRcpDataSw9Ofs;
  Field_t *mpRcpDataSw9SelA;
  Field_t *mpRcpDataSw9SelB;

  Field_t *mpRcpDataDw8Dyn;    // substituted Sw<x> from v6+
  Field_t *mpRcpDataDw8Ofs;    // substituted Sw<x> from v6+
  Field_t *mpRcpDataDw8SelA;   // substituted Sw<x> from v6+
  Field_t *mpRcpDataDw8SelB;   // substituted Sw<x> from v6+
  Field_t *mpRcpDataDw10Dyn;   // substituted Sw<x> from v6+
  Field_t *mpRcpDataDw10Ofs;   // substituted Sw<x> from v6+
  Field_t *mpRcpDataDw10SelA;  // substituted Sw<x> from v6+
  Field_t *mpRcpDataDw10SelB;  // substituted Sw<x> from v6+

  Field_t *mpRcpDataSwxOvsSb;
  Field_t *mpRcpDataSwxCch;
  Field_t *mpRcpDataSwxSelA;
  Field_t *mpRcpDataSwxSelB;
  Field_t *mpRcpDataMaskA;
  Field_t *mpRcpDataMaskB;
  Field_t *mpRcpDataDual;
  Field_t *mpRcpDataPaired;
  Field_t *mpRcpDataElA;
  Field_t *mpRcpDataElB;
  Field_t *mpRcpDataInfoA;
  Field_t *mpRcpDataInfoB;
  Field_t *mpRcpDataFtmA;
  Field_t *mpRcpDataFtmB;
  Field_t *mpRcpDataBankA;
  Field_t *mpRcpDataBankB;
  Field_t *mpRcpDataKlA;
  Field_t *mpRcpDataKlB;
  Field_t *mpRcpDataFlowSet;
  Field_t *mpRcpDataKeywayA;
  Field_t *mpRcpDataKeywayB;
  Field_t *mpRcpDataSynergyMode;
  Field_t *mpRcpDataDw0BDyn;
  Field_t *mpRcpDataDw0BOfs;
  Field_t *mpRcpDataDw2BDyn;
  Field_t *mpRcpDataDw2BOfs;
  Field_t *mpRcpDataSw4BDyn;
  Field_t *mpRcpDataSw4BOfs;
  Field_t *mpRcpDataSw5BDyn;
  Field_t *mpRcpDataSw5BOfs;

  Register_t *mpCamCtrl;
  Field_t *mpCamAddr;
  Field_t *mpCamCnt;
  Register_t *mpCamData;
  Field_t *mpCamDataW0;
  Field_t *mpCamDataW1;
  Field_t *mpCamDataW2;
  Field_t *mpCamDataW3;
  Field_t *mpCamDataW4;
  Field_t *mpCamDataW5;
  Field_t *mpCamDataFt0;
  Field_t *mpCamDataFt1;
  Field_t *mpCamDataFt2;
  Field_t *mpCamDataFt3;
  Field_t *mpCamDataFt4;
  Field_t *mpCamDataFt5;

  Register_t *mpTcamCtrl;
  Field_t *mpTcamAddr;
  Field_t *mpTcamCnt;
  Register_t *mpTcamData;
  Field_t *mpTcamDataT;

  Register_t *mpTciCtrl;
  Field_t *mpTciAddr;
  Field_t *mpTciCnt;
  Register_t *mpTciData;
  Field_t *mpTciDataColor;
  Field_t *mpTciDataFt;

  Register_t *mpTcqCtrl;
  Field_t *mpTcqAddr;
  Field_t *mpTcqCnt;
  Register_t *mpTcqData;
  Field_t *mpTcqDataBankMask;
  Field_t *mpTcqDataQual;
};

#endif //__FLOW_NTHW_KM_H__
