#ifndef __FLOW_NTHW_PDB_H__
#define __FLOW_NTHW_PDB_H__

#include <stdint.h> // uint32_t
#include "nthw_fpga_model.h"

struct PdbNthw {
  uint8_t mPhysicalAdapterNo;
  Fpga_t *mpFpga;

  Module_t *mPdb;

  Register_t *mpRcpCtrl;
  Field_t *mpRcpAddr;
  Field_t *mpRcpCnt;
  Register_t *mpRcpData;
  Field_t *mpRcpDataDescriptor;
  Field_t *mpRcpDataDescLen;
  Field_t *mpRcpDataTxPort;
  Field_t *mpRcpDataTxIgnore;
  Field_t *mpRcpDataTxNow;
  Field_t *mpRcpDataCrcOverwrite;
  Field_t *mpRcpDataAlign;
  Field_t *mpRcpDataOfs0Dyn;
  Field_t *mpRcpDataOfs0Rel;
  Field_t *mpRcpDataOfs1Dyn;
  Field_t *mpRcpDataOfs1Rel;
  Field_t *mpRcpDataOfs2Dyn;
  Field_t *mpRcpDataOfs2Rel;
  Field_t *mpRcpDataIpProtTnl;
  Field_t *mpRcpDataPpcHsh;
  Field_t *mpRcpDataDuplicateEn;
  Field_t *mpRcpDataDuplicateBit;
  Field_t *mpRcpDataPcapKeepFcs;

  Register_t *mpConfig;
  Field_t *mpConfigTsFormat;
  Field_t *mpConfigPortOfs;
};

typedef struct PdbNthw PdbNthw_t;
// typedef struct PdbNthw PdbNthw;

//
//
//
struct PdbNthw *PdbNthw_new(void);
void PdbNthw_delete(struct PdbNthw *p);
int PdbNthw_init(struct PdbNthw *p, Fpga_t *pFpga, int nInstance);
//
int PdbNthw_setup(struct PdbNthw *p, int nIdx, int nIdxCnt);
void pdbNthw_setDebugMode(struct PdbNthw *p, unsigned nDebugMode);
//

#if 0
uint32_t GetVersionMajor(void) {return (mPdb.getVersion()).getMajorVersion();}
uint32_t GetVersionMinor(void) {return (mPdb.getVersion()).getMinorVersion();}
void SetDebugOutput(int on) {if (on) mPdb.setDebugMode(Register::ON_WRITE); else mPdb.setDebugMode(Register::NO_DEBUG);}
#endif

// RCP
void PdbNthw_RcpSelect(const struct PdbNthw *p, uint32_t val);
void PdbNthw_RcpCnt(const struct PdbNthw *p, uint32_t val);

void PdbNthw_RcpDescriptor(const struct PdbNthw *p, uint32_t val);
void PdbNthw_RcpDescLen(const struct PdbNthw *p, uint32_t val);
void PdbNthw_RcpTxPort(const struct PdbNthw *p, uint32_t val);
void PdbNthw_RcpTxIgnore(const struct PdbNthw *p, uint32_t val);
void PdbNthw_RcpTxNow(const struct PdbNthw *p, uint32_t val);
void PdbNthw_RcpCrcOverwrite(const struct PdbNthw *p, uint32_t val);
void PdbNthw_RcpAlign(const struct PdbNthw *p, uint32_t val);
void PdbNthw_RcpOfs0Dyn(const struct PdbNthw *p, uint32_t val);
void PdbNthw_RcpOfs0Rel(const struct PdbNthw *p, int32_t val);
void PdbNthw_RcpOfs1Dyn(const struct PdbNthw *p, uint32_t val);
void PdbNthw_RcpOfs1Rel(const struct PdbNthw *p, int32_t val);
void PdbNthw_RcpOfs2Dyn(const struct PdbNthw *p, uint32_t val);
void PdbNthw_RcpOfs2Rel(const struct PdbNthw *p, int32_t val);
void PdbNthw_RcpIpProtTnl(const struct PdbNthw *p, uint32_t val);
void PdbNthw_RcpPpcHsh(const struct PdbNthw *p, uint32_t val);
void PdbNthw_RcpDuplicateEn(const struct PdbNthw *p, uint32_t val);
void PdbNthw_RcpDuplicateBit(const struct PdbNthw *p, uint32_t val);
void PdbNthw_RcpDataPcapKeepFcs(const struct PdbNthw *p, uint32_t val);
void PdbNthw_RcpFlush(const struct PdbNthw *p);

// CONFIG
void PdbNthw_ConfigTsFormat(const struct PdbNthw *p, uint32_t val);
void PdbNthw_ConfigPortOfs(const struct PdbNthw *p, uint32_t val);
void PdbNthw_ConfigPortOfs(const struct PdbNthw *p, uint32_t val);
void PdbNthw_ConfigFlush(const struct PdbNthw *p);

#endif //__FLOW_NTHW_PDB_H__
