#ifndef __FLOW_NTHW_RPP_LR_H__
#define __FLOW_NTHW_RPP_LR_H__

#include <stdint.h>
#include "nthw_fpga_model.h"

struct RppLrNthw {
  uint8_t mPhysicalAdapterNo;
  Fpga_t *mpFpga;

  Module_t *mRppLr;

  Register_t *mpRcpCtrl;
  Field_t *mpRcpAddr;
  Field_t *mpRcpCnt;

  Register_t *mpRcpData;
  Field_t *mpRcpDataExp;
};

//
//
//
struct RppLrNthw *RppLrNthw_new(void);
void RppLrNthw_delete(struct RppLrNthw *p);
int RppLrNthw_init(struct RppLrNthw *p, Fpga_t *pFpga, int nInstance);
//
int RppLrNthw_setup(struct RppLrNthw *p, int nIdx, int nIdxCnt);
void rppLrNthw_setDebugMode(struct RppLrNthw *p, unsigned nDebugMode);
//

#if 0
  uint32_t GetVersionMajor(void) {return (mRppLr.getVersion()).getMajorVersion();}
  uint32_t GetVersionMinor(void) {return (mRppLr.getVersion()).getMinorVersion();}
  void SetDebugOutput(int on) {if (on) mRppLr.setDebugMode(Register::ON_WRITE); else mRppLr.setDebugMode(Register::NO_DEBUG);}
#endif

// RCP
void RppLrNthw_RcpSelect(const struct RppLrNthw *p, uint32_t val);
void RppLrNthw_RcpCnt(const struct RppLrNthw *p, uint32_t val);
void RppLrNthw_RcpExp(const struct RppLrNthw *p, uint32_t val);
void RppLrNthw_RcpFlush(const struct RppLrNthw *p);

#endif //__FLOW_NTHW_RPP_LR_H__
