#ifndef __FLOW_NTHW_SLC_H__
#define __FLOW_NTHW_SLC_H__

#include <stdint.h> // uint32_t
#include "nthw_fpga_model.h"

struct SlcNthw {
  uint8_t mPhysicalAdapterNo;
  Fpga_t *mpFpga;

  Module_t *mSlc;

  Register_t *mpRcpCtrl;
  Field_t *mpRcpAddr;
  Field_t *mpRcpCnt;
  Register_t *mpRcpData;

  Field_t *mpRcpDataTailSlcEn;
  Field_t *mpRcpDataTailDyn;
  Field_t *mpRcpDataTailOfs;
  Field_t *mpRcpDataPcap;
};

typedef struct SlcNthw SlcNthw_t;
//typedef struct SlcNthw SlcNthw;

//
//
//
struct SlcNthw *SlcNthw_new(void);
void SlcNthw_delete(struct SlcNthw *p);
int SlcNthw_init(struct SlcNthw *p, Fpga_t *pFpga, int nInstance);
//
int SlcNthw_setup(struct SlcNthw *p, int nIdx, int nIdxCnt);
void slcNthw_setDebugMode(struct SlcNthw *p, unsigned nDebugMode);
//

#if 0
  uint32_t GetVersionMajor(void) {return (mSlc.getVersion()).getMajorVersion();}
  uint32_t GetVersionMinor(void) {return (mSlc.getVersion()).getMinorVersion();}
  void SetDebugOutput(int on) {if (on) mSlc.setDebugMode(Register::ON_WRITE); else mSlc.setDebugMode(Register::NO_DEBUG);}
#endif

// RCP
void SlcNthw_RcpSelect(const struct SlcNthw *p, uint32_t val);
void SlcNthw_RcpCnt(const struct SlcNthw *p, uint32_t val);
void SlcNthw_RcpTailSlcEn(const struct SlcNthw *p, uint32_t val);
void SlcNthw_RcpTailDyn(const struct SlcNthw *p, uint32_t val);
void SlcNthw_RcpTailOfs(const struct SlcNthw *p, int32_t val);
void SlcNthw_RcpPcap(const struct SlcNthw *p, uint32_t val);
void SlcNthw_RcpFlush(const struct SlcNthw *p);

#endif //__FLOW_NTHW_SLC_H__
