#ifndef __FLOW_NTHW_TX_CPY_H__
#define __FLOW_NTHW_TX_CPY_H__

#include <stdint.h>
#include "nthw_fpga_model.h"

struct TxCpyWriters_s {
  Register_t *mpWriterCtrl;
  Field_t *mpWriterCtrlAddr;
  Field_t *mpWriterCtrlCnt;

  Register_t *mpWriterData;
  Field_t *mpWriterDataReaderSelect;
  Field_t *mpWriterDataDyn;
  Field_t *mpWriterDataOfs;
  Field_t *mpWriterDataLen;
  Field_t *mpWriterDataMaskPointer;

  Register_t *mpWriterMaskCtrl;
  Field_t *mpWriterMaskCtrlAddr;
  Field_t *mpWriterMaskCtrlCnt;

  Register_t *mpWriterMaskData;
  Field_t *mpWriterMaskDataByteMask;
};

struct TxCpyNthw {
  uint8_t mPhysicalAdapterNo;
  Fpga_t *mpFpga;

  Module_t *mTxCpy;

  unsigned mWritersCnt;
  struct TxCpyWriters_s *mWriters;
};

//
//
//
struct TxCpyNthw *TxCpyNthw_new(void);
void TxCpyNthw_delete(struct TxCpyNthw *p);
int TxCpyNthw_init(struct TxCpyNthw *p, Fpga_t *pFpga, int nInstance);
//
int TxCpyNthw_setup(struct TxCpyNthw *p, int nIdx, int nIdxCnt);
void txCpyNthw_setDebugMode(struct TxCpyNthw *p, unsigned nDebugMode);
//

#if 0
  uint32_t GetVersionMajor(void) {return (mTxCpy.getVersion()).getMajorVersion();}
  uint32_t GetVersionMinor(void) {return (mTxCpy.getVersion()).getMinorVersion();}
  void SetDebugOutput(int on) {if (on) mTxCpy.setDebugMode(Register::ON_WRITE); else mTxCpy.setDebugMode(Register::NO_DEBUG);}
#endif

void TxCpyNthw_WriterSelect(const struct TxCpyNthw *p, unsigned index, uint32_t val);
void TxCpyNthw_WriterCnt(const struct TxCpyNthw *p, unsigned index, uint32_t val);
void TxCpyNthw_WriterReaderSelect(const struct TxCpyNthw *p, unsigned index, uint32_t val);
void TxCpyNthw_WriterDyn(const struct TxCpyNthw *p, unsigned index, uint32_t val);
void TxCpyNthw_WriterOfs(const struct TxCpyNthw *p, unsigned index, uint32_t val);
void TxCpyNthw_WriterLen(const struct TxCpyNthw *p, unsigned index, uint32_t val);
void TxCpyNthw_WriterMaskPointer(const struct TxCpyNthw *p, unsigned index, uint32_t val);
void TxCpyNthw_WriterFlush(const struct TxCpyNthw *p, unsigned index);

void TxCpyNthw_WriterMaskSelect(const struct TxCpyNthw *p, unsigned index, uint32_t val);
void TxCpyNthw_WriterMaskCnt(const struct TxCpyNthw *p, unsigned index, uint32_t val);
void TxCpyNthw_WriterMask(const struct TxCpyNthw *p, unsigned index, uint32_t val);
void TxCpyNthw_WriterMaskFlush(const struct TxCpyNthw *p, unsigned index);

#endif //__FLOW_NTHW_TX_CPY_H__
