#ifndef __FLOW_NTHW_TX_INS_H__
#define __FLOW_NTHW_TX_INS_H__

#include <stdint.h>
#include "nthw_fpga_model.h"

struct TxInsNthw {
  uint8_t mPhysicalAdapterNo;
  Fpga_t *mpFpga;

  Module_t *mTxIns;

  Register_t *mpRcpCtrl;
  Field_t *mpRcpAddr;
  Field_t *mpRcpCnt;

  Register_t *mpRcpData;
  Field_t *mpRcpDataDyn;
  Field_t *mpRcpDataOfs;
  Field_t *mpRcpDataLen;
};

//
//
//
struct TxInsNthw *TxInsNthw_new(void);
void TxInsNthw_delete(struct TxInsNthw *p);
int TxInsNthw_init(struct TxInsNthw *p, Fpga_t *pFpga, int nInstance);
//
int TxInsNthw_setup(struct TxInsNthw *p, int nIdx, int nIdxCnt);
void txInsNthw_setDebugMode(struct TxInsNthw *p, unsigned nDebugMode);
//

#if 0
  uint32_t GetVersionMajor(void) {return (mTxIns.getVersion()).getMajorVersion();}
  uint32_t GetVersionMinor(void) {return (mTxIns.getVersion()).getMinorVersion();}
  void SetDebugOutput(int on) {if (on) mTxIns.setDebugMode(Register::ON_WRITE); else mTxIns.setDebugMode(Register::NO_DEBUG);}
#endif

// RCP
void TxInsNthw_RcpSelect(const struct TxInsNthw *p, uint32_t val);
void TxInsNthw_RcpCnt(const struct TxInsNthw *p, uint32_t val);
void TxInsNthw_RcpDyn(const struct TxInsNthw *p, uint32_t val);
void TxInsNthw_RcpOfs(const struct TxInsNthw *p, uint32_t val);
void TxInsNthw_RcpLen(const struct TxInsNthw *p, uint32_t val);
void TxInsNthw_RcpFlush(const struct TxInsNthw *p);

#endif //__FLOW_NTHW_TX_INS_H__
