#ifndef __FLOW_NTHW_TX_RPL_H__
#define __FLOW_NTHW_TX_RPL_H__

#include <stdint.h>
#include "nthw_fpga_model.h"

struct TxRplNthw {
  uint8_t mPhysicalAdapterNo;
  Fpga_t *mpFpga;

  Module_t *mTxRpl;

  Register_t *mpRcpCtrl;
  Field_t *mpRcpCtrlAddr;
  Field_t *mpRcpCtrlCnt;

  Register_t *mpRcpData;
  Field_t *mpRcpDataDyn;
  Field_t *mpRcpDataOfs;
  Field_t *mpRcpDataLen;
  Field_t *mpRcpDataRplPtr;
  Field_t *mpRcpDataExtPrio;

  Register_t *mpExtCtrl;
  Field_t *mpExtCtrlAddr;
  Field_t *mpExtCtrlCnt;

  Register_t *mpExtData;
  Field_t *mpExtDataRplPtr;

  Register_t *mpRplCtrl;
  Field_t *mpRplCtrlAddr;
  Field_t *mpRplCtrlCnt;

  Register_t *mpRplData;
  Field_t *mpRplDataValue;
};

//
//
//
struct TxRplNthw *TxRplNthw_new(void);
void TxRplNthw_delete(struct TxRplNthw *p);
int TxRplNthw_init(struct TxRplNthw *p, Fpga_t *pFpga, int nInstance);
//
int TxRplNthw_setup(struct TxRplNthw *p, int nIdx, int nIdxCnt);
void txRplNthw_setDebugMode(struct TxRplNthw *p, unsigned nDebugMode);
//

#if 0
  uint32_t GetVersionMajor(void) {return (mTxRpl.getVersion()).getMajorVersion();}
  uint32_t GetVersionMinor(void) {return (mTxRpl.getVersion()).getMinorVersion();}
  void SetDebugOutput(int on) {if (on) mTxRpl.setDebugMode(Register::ON_WRITE); else mTxRpl.setDebugMode(Register::NO_DEBUG);}
#endif

// RCP
void TxRplNthw_RcpSelect(const struct TxRplNthw *p, uint32_t val);
void TxRplNthw_RcpCnt(const struct TxRplNthw *p, uint32_t val);
void TxRplNthw_RcpDyn(const struct TxRplNthw *p, uint32_t val);
void TxRplNthw_RcpOfs(const struct TxRplNthw *p, uint32_t val);
void TxRplNthw_RcpLen(const struct TxRplNthw *p, uint32_t val);
void TxRplNthw_RcpRplPtr(const struct TxRplNthw *p, uint32_t val);
void TxRplNthw_RcpExtPrio(const struct TxRplNthw *p, uint32_t val);
void TxRplNthw_RcpFlush(const struct TxRplNthw *p);

void TxRplNthw_ExtSelect(const struct TxRplNthw *p, uint32_t val);
void TxRplNthw_ExtCnt(const struct TxRplNthw *p, uint32_t val);
void TxRplNthw_ExtRplPtr(const struct TxRplNthw *p, uint32_t val);
void TxRplNthw_ExtFlush(const struct TxRplNthw *p);

void TxRplNthw_RplSelect(const struct TxRplNthw *p, uint32_t val);
void TxRplNthw_RplCnt(const struct TxRplNthw *p, uint32_t val);
void TxRplNthw_RplValue(const struct TxRplNthw *p, const uint32_t* val);
void TxRplNthw_RplFlush(const struct TxRplNthw *p);

#endif //__FLOW_NTHW_TX_RPL_H__
