#ifndef NTHW_EPP_HPP_
#define NTHW_EPP_HPP_

//
//
//

// VXLAN adds extra 50 bytes
#define VXLANDATASIZEADJUST 50
#define VXLANDATASIZEADJUSTIPV6 70
#define MTUINITVAL 1500
#define NRECIPE 3

// List of size adjust values to put in the recipe memory data register at startup
static const int rcpDataSizeAdjustTxp[NRECIPE] = {0, VXLANDATASIZEADJUST, VXLANDATASIZEADJUSTIPV6};
static const int rcpDataSizeAdjustVport[NRECIPE] = {0, VXLANDATASIZEADJUST, VXLANDATASIZEADJUSTIPV6};

//
//
//
struct NthwEpp_s
{

  Fpga_t *mpFpga;
  Module_t *mpModEpp;
  int mnInstance;
  int mnEppCategories;

  Register_t *mpRegReciepeMemoryControl;
  Field_t    *mpFldReciepeMemoryControlAdr;
  Field_t    *mpFldReciepeMemoryControlCnt;

  Register_t *mpRegReciepeMemoryData;
  Field_t    *mpFldReciepeMemoryDataTxMtuEppEnable;
  Field_t    *mpFldReciepeMemoryDataQueueMtuEppEnable;
  Field_t    *mpFldReciepeMemoryDataSizeAdjustTxPort;
  Field_t    *mpFldReciepeMemoryDataSizeAdjustVirtualPort;
  Field_t    *mpFldReciepeMemoryDataFixed18bL2Mtu;
  Field_t    *mpFldReciepeMemoryDataTxpQosEppEnable;
  Field_t    *mpFldReciepeMemoryDataQueueQosEppEnable;

  Register_t *mpRegTxpPortMtuControl;
  Field_t    *mpFldTxpPortMtuControlAdr;
  Field_t    *mpFldTxpPortMtuControlCnt;

  Register_t *mpRegTxpPortMtuData;
  Field_t    *mpFldTxpPortMtuDataMaxMtu;

  Register_t *mpRegQueueMtuControl;
  Field_t    *mpFldQueueMtuControlAdr;
  Field_t    *mpFldQueueMtuControlCnt;

  Register_t *mpRegQueueMtuData;
  Field_t    *mpFldQueueMtuDataMaxMtu;

  Register_t *mpRegTxpQosControl;
  Field_t    *mpFldTxpQosControlAdr;
  Field_t    *mpFldTxpQosControlCnt;

  Register_t *mpRegTxpQosData;
  Field_t    *mpFldTxpQosDataEnable;
  Field_t    *mpFldTxpQosDataInformationRate;
  Field_t    *mpFldTxpQosDataInformationRateFractional;
  Field_t    *mpFldTxpQosDataBurstSize;

  Register_t *mpRegVportQosControl;
  Field_t    *mpFldVportQosControlAdr;
  Field_t    *mpFldVportQosControlCnt;

  Register_t *mpRegVportQosData;
  Field_t    *mpFldVportQosDataEnable;
  Field_t    *mpFldVportQosDataInformationRate;
  Field_t    *mpFldVportQosDataInformationRateFractional;
  Field_t    *mpFldVportQosDataBurstSize;

  Register_t *mpRegQueueVportControl;
  Field_t    *mpFldQueueVportControlAdr;
  Field_t    *mpFldQueueVportControlCnt;

  Register_t *mpRegQueueVportData;
  Field_t    *mpFldQueueVportDataVport;
};

typedef struct NthwEpp_s NthwEpp_t;

NthwEpp_t* NthwEpp_new(void);
void NthwEpp_delete(NthwEpp_t* p);

int NthwEpp_present(Fpga_t *pFpga, int nInstance);
int NthwEpp_init(NthwEpp_t *p, Fpga_t *pFpga, int nInstance);
int NthwEpp_setup(NthwEpp_t *p);
int NthwEpp_setMtu(NthwEpp_t *p, uint32_t port, uint32_t maxMtu, NtMetaPortType_t portType);
int NthwEpp_setTxpQos(NthwEpp_t *p, uint32_t port, uint32_t informationRate, uint32_t informationRateFractional, uint32_t burstSize);
int NthwEpp_setVportQos(NthwEpp_t *p, uint32_t port, uint32_t informationRate, uint32_t informationRateFractional, uint32_t burstSize);
int NthwEpp_setQueueToVport(NthwEpp_t *p, uint32_t qid, uint32_t vport);

#endif
