//
// nthw_mcu.h
//

/*
 * %NT_SOFTWARE_LICENSE%
 */


/*
 * %NT_SOFTWARE_LICENSE%
 */


//
//
//
#ifndef NTHW_MCU_H_
#define NTHW_MCU_H_

//
//
//
struct NthwMcu
{
  //
  Fpga_t* mpFpga;
  Module_t* mpModMcu;
  int mnInstance;
  //
  int mnModuleMajorVersion;
  int mnModuleMinorVersion;
  //
  uint64_t mnModuleVersionPacked64;
  //
  bool mb_McuPresent;
  int mn_McuType;
  int mn_McuDramSize;
  //
  Register_t* mpRegCsr;
  Field_t* mpFldCsrHalt;
  Field_t* mpFldCsrPause;
  Field_t* mpFldCsrReset;

  //
  Register* mpRegDramCtrl;
  Field_t* mpFldDramCtrlAdr;
  Field_t* mpFldDramCtrlCnt;

  //
  Register* mpRegDramRdData;
  Field_t* mpFldDramRdDataData;
  //
  Register* mpRegDramWrData;
  Field_t* mpFldDramWrDataData;

  //
  Register* mpRegIramCtrl;
  Field_t* mpFldIramCtrlAdr;
  Field_t* mpFldIramCtrlCnt;

  //
  Register* mpRegIramData;
  Field_t* mpFldIramDataData;

};


typedef struct NthwMcu NthwMcu_t;
typedef struct NthwMcu NthwMcu;

//
//
//
NthwMcu_t* NthwMcu_new(void);
void NthwMcu_delete(NthwMcu_t* p);
int NthwMcu_init(NthwMcu_t *p, Fpga_t *pFpga, int nInstance);
//
void NthwMcu_setHalt(NthwMcu_t* p, uint32_t value);
uint32_t NthwMcu_getHalt(NthwMcu_t* p);
//
void NthwMcu_setPause(NthwMcu_t* p, uint32_t value);
uint32_t NthwMcu_getPause(NthwMcu_t* p);
//
void NthwMcu_setReset(NthwMcu_t* p, uint32_t value);
uint32_t NthwMcu_getReset(NthwMcu_t* p);
//
int NthwMcu_DramRead(NthwMcu_t *p, uint32_t nAddr, uint8_t* pData, int nDataCnt);
int NthwMcu_DramWrite(NthwMcu_t *p, uint32_t nAddr, uint8_t* pData, int nDataCnt);
//
int NthwMcu_IramRead(NthwMcu_t *p, uint32_t nAddr, uint8_t* pData, int nDataCnt);
int NthwMcu_IramWrite(NthwMcu_t *p, uint32_t nAddr, uint8_t* pData, int nDataCnt);
//
//
//
#endif // NTHW_MCU_H_

//
// EOF
//
