//
// nthw_stat.h
//

/*
 * %NT_SOFTWARE_LICENSE%
 */

//
//
//

#ifndef __NTHW_STAT_H__
#define __NTHW_STAT_H__


//
//
//
struct NthwStat
{
  Fpga_t* mpFpga;
  //
  Module_t* mpModStat;
  //
  int mnInstance;
  //
  int mnStatLayoutVersion;
  //
  bool mbIsVswitch;
  bool mbHasTxStats;
  //
  int mNbPhyPorts;
  int mNbNimPorts;
  //
  int mNbRxPorts;
  int mNbTxPorts;
  //
  int mNbRxHostBuffers;
  int mNbTxHostBuffers;

  int mDbsPresent;

  //
  int mRxPortReplicate;
  //
  int mNbColorCounters;
  //
  int mNbRxHbCounters;
  int mNbTxHbCounters;
  //
  int mNbRxPortCounters;
  int mNbTxPortCounters;
  //
  int mNbCounters;
  //
  Field_t* mpFldDmaEna;
  Field_t* mpFldCntClear;
  //
  Field_t* mpFldTxDisable;
  //
  Field_t* mpFldCntFreeze;
  //
  Field_t* mpFldStatToggleMissed;
  //
  Field_t* mpFldDmaLsb;
  Field_t* mpFldDmaMsb;
  //
  uint64_t mStatDmaPhysical;
  uint32_t* mpStatDmaVirtual;
  //
  uint64_t lastTs;
  //
/*
  union Timestamp {
    uint32_t w32[2];
    uint64_t w64;
  };
  Timestamp* mpTimestamp;
*/
  //
  uint64_t* mpTimestamp;
  //
};

typedef struct NthwStat NthwStat_t;
typedef struct NthwStat NthwStat;


//
//
//
NthwStat_t* NthwStat_new(void);
int NthwStat_init(NthwStat_t *p, Fpga_t *pFpga, int nInstance);
void NthwStat_delete(NthwStat_t* p);
//
int NthwStat_setDmaAddress(NthwStat_t* p, uint64_t statDmaPhysical, uint32_t* pStatDmaVirtual);
int NthwStat_trigger(NthwStat_t* p);
//
//
//
#endif // __NTHW_STAT_H__

//
// EOF
//

