#include "tempmon.h"
#include "ntlog.h"
#include "nthw_register.h"


struct nt_fpga_sensor_monitor* Tempmon_new(void) {
    struct nt_fpga_sensor_monitor* temp = malloc(sizeof(struct nt_fpga_sensor_monitor));
    if (temp == NULL) {
        NT_LOG(ERR, ETHDEV, "%s: monitor is NULL\n", __func__);
    }
    return temp;
}

void Tempmon_init(struct nt_fpga_sensor_monitor *t, Fpga_t *pFpga) {
    if (t == NULL || pFpga == NULL) {
        NT_LOG(ERR, ETHDEV, "%s: bad argument(s)\n", __func__);
        return;
    }
    // fetch initialized module
    t->FPGA = pFpga;
    t->mod = Nthw_getModule(t->FPGA, MOD_TEMPMON, 0);
    if(t->mod == NULL) {
        NT_LOG(ERR, ETHDEV, "module is NULL\n");
    }
    // fetch register
    t->reg = Module_getRegister(t->mod, TEMPMON_STAT);
    if(t->reg == NULL) {
        NT_LOG(ERR, ETHDEV, "register is NULL\n");
    }
    // fetch fields
    t->fields = malloc(sizeof(Field*));
    if(t->fields == NULL){
        NT_LOG(ERR, ETHDEV, "%s: field is NULL", __func__);
        return;
    }
    t->fields[0] = Register_getField(t->reg, TEMPMON_STAT_TEMP);
    if(t->fields[0] == NULL) {
        NT_LOG(ERR, ETHDEV, "field is NULL\n");
    }
}
