//
// config.c
//

/*
 * %NT_SOFTWARE_LICENSE%
 */


/*
 * TODO THIS IS AN INITIAL VERSION OF A CONFIG TOOL.
 * TO BE FINISHED...
 *
 */


#include <unistd.h>
#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>
#include "config.h"
#include "argparse.h"

int adapter = 0;
char *set_opt = NULL;
char *get_opt = NULL;

struct argparse_option options[] = {
  OPT_HELP(),
  OPT_STRING('s', "set", &set_opt, "Specifies set operation of the tool", NULL, 0, 0),
  OPT_STRING('g', "get", &get_opt, "Specifies get operation of the tool", NULL, 0, 0),
  OPT_INTEGER('a', 0, &adapter, "Specifies the adapter that the tool is to operate on", NULL, 0, 0),
  OPT_END(),
};


static int link_speed(enum port_speed link_speed)
{
  switch (link_speed) {
    case PORT_LINK_SPEED_10M:
      return 10;
    case PORT_LINK_SPEED_100M:
      return 100;
    case PORT_LINK_SPEED_1G:
      return 1000;
    case PORT_LINK_SPEED_10G:
      return 10000;
    case PORT_LINK_SPEED_25G:
      return 25000;
    case PORT_LINK_SPEED_40G:
      return 40000;
    case PORT_LINK_SPEED_50G:
      return 50000;
    case PORT_LINK_SPEED_100G:
      return 100000;
    default:
      break;
 }
  return 0;
}


const char* translate_nim_id(enum nim_identifier_e nim_id)
{
  switch (nim_id) {
  case NIM_UNKNOWN     : return "NotAvail";
  case NIM_GBIC        : return "GBIC";
  case NIM_FIXED       : return "FIXED";
  case NIM_SFP_SFP_PLUS: return "SFP/SFP+";
  case NIM_300_PIN_XBI : return "300 pin XBI";
  case NIM_XEN_PAK     : return "XEN-PAK";
  case NIM_XFP         : return "XFP";
  case NIM_XFF         : return "XFF";
  case NIM_XFP_E       : return "XFP-E";
  case NIM_X2          : return "X2";
  case NIM_DWDM        : return "DWDM";
  case NIM_QSFP        : return "QSFP";
  case NIM_QSFP_PLUS   : return "QSFP+";
  case NIM_QSFP28      : return "QSFP28";
  case NIM_CFP4        : return "CFP4";
  default:
    return "Unhandled";
  }
}


const char* translate_port_type(enum port_type_e port_type)
{
  switch (port_type) {
  case PORT_TYPE_NOT_AVAILABLE        : return "NotAvail";
  case PORT_TYPE_NOT_RECOGNISED       : return "NotRecog";
  case PORT_TYPE_RJ45                 : return "RJ45";
  case PORT_TYPE_SFP_FX               : return "SFP-FX";
  case PORT_TYPE_SFP_SX               : return "SFP-SX";
  case PORT_TYPE_SFP_SX_DD            : return "SFP-SX-DD";
  case PORT_TYPE_SFP_LX               : return "SFP-LX";
  case PORT_TYPE_SFP_LX_DD            : return "SFP-LX-DD";
  case PORT_TYPE_SFP_ZX               : return "SFP-ZX";
  case PORT_TYPE_SFP_ZX_DD            : return "SFP-ZX-DD";
  case PORT_TYPE_SFP_CU               : return "SFP-CU";
  case PORT_TYPE_SFP_CU_DD            : return "SFP-CU-DD";
  case PORT_TYPE_SFP_NOT_RECOGNISED   : return "SFP-NotRecog";
  case PORT_TYPE_XFP                  : return "XFP";
  case PORT_TYPE_XPAK                 : return "XPAK";
  case PORT_TYPE_SFP_CU_TRI_SPEED     : return "SFP-TRI";
  case PORT_TYPE_SFP_CU_TRI_SPEED_DD  : return "SFP-TRI-DD";
  case PORT_TYPE_SFP_PLUS             : return "SFP+";
  case PORT_TYPE_QSFP_PLUS            : return "QSFP+";
  case PORT_TYPE_QSFP_PLUS_4X10       : return "QSFP+"; //Deprecated enum
  case PORT_TYPE_QSFP_PASSIVE_DAC     : return "QSFP+ P-DAC";
  case PORT_TYPE_QSFP_ACTIVE_DAC      : return "QSFP+ A-DAC";
  case PORT_TYPE_QSFP28               : return "QSFP28";
  case PORT_TYPE_QSFP28_LR4           : return "QSFP28-LR4";
  case PORT_TYPE_QSFP28_SR4           : return "QSFP28-SR4";
  case PORT_TYPE_SFP_NOT_PRESENT      : return "SFP Empty";
  case PORT_TYPE_SFP_PLUS_NOT_PRESENT : return "SFP+ Empty";
  case PORT_TYPE_XFP_NOT_PRESENT      : return "XFP Empty";
  case PORT_TYPE_QSFP_PLUS_NOT_PRESENT: return "QSFP+ Empty";
  case PORT_TYPE_QSFP28_NOT_PRESENT   : return "QSFP28 Empty";
  case PORT_TYPE_SFP_PLUS_PASSIVE_DAC : return "Passive DAC";
  case PORT_TYPE_SFP_PLUS_ACTIVE_DAC  : return "Active DAC";
  case PORT_TYPE_CFP4_LR4             : return "CFP4-LR4";
  case PORT_TYPE_CFP4_NOT_PRESENT     : return "CFP4 Empty";
  case PORT_TYPE_INITIALIZE           : return "Initialize";
  case PORT_TYPE_NIM_NOT_PRESENT      : return "Empty";
  case PORT_TYPE_HCB                  : return "HCB";
  case PORT_TYPE_NOT_SUPPORTED        : return "NotSupp";
  case PORT_TYPE_SFP_PLUS_DUAL_RATE   : return "SFP+_DR";
  case PORT_TYPE_CFP4_SR4             : return "CFP4_SR4";
  case PORT_TYPE_SFP_28               : return "SFP28";
  case PORT_TYPE_SFP_28_SR            : return "SFP28-SR";
  case PORT_TYPE_SFP_28_LR            : return "SFP28-LR";
  case PORT_TYPE_SFP_28_CR_CA_L       : return "SFP28-CR-L";
  case PORT_TYPE_SFP_28_CR_CA_S       : return "SFP28-CR-S";
  case PORT_TYPE_SFP_28_CR_CA_N       : return "SFP28-CR-N";
  case PORT_TYPE_QSFP28_CR_CA_L       : return "QSFP28-CR-L";
  case PORT_TYPE_QSFP28_CR_CA_S       : return "QSFP28-CR-S";
  case PORT_TYPE_QSFP28_CR_CA_N       : return "QSFP28-CR-N";
  case PORT_TYPE_SFP_28_SR_DR         : return "SFP28-SR-DR";
  case PORT_TYPE_SFP_28_LR_DR         : return "SFP28-LR-DR";
  case PORT_TYPE_SFP_PLUS_CU          : return "SFP+_CU";
  default:
    return "Unhandled";
  }
}


static int parse_server_reply(int len, uint8_t *data, struct reply_err_s *reply_status) {
  if (len) {

    /* During set parameter request we got some data from server, that indicate
     * backend module error.
     */

    uint32_t status_code = *(uint32_t *)data;

    if (status_code == NTCONN_ADAPTER_ERR_WRONG_LINK_STATE) {
      fprintf(stderr, "Failed to set parameter, firstly disable port\n");
    }
    else if (status_code == NTCONN_ADAPTER_ERR_PORT_STATE_FAIL) {
      fprintf(stderr, "Failed to change port state\n");
    }
    else if (status_code == NTCONN_ADAPTER_ERR_TX_POWER_FAIL) {
      fprintf(stderr, "Failed to change tx power\n");
    }
    else {
      fprintf(stderr, "Error setting port parameter\n");
    }
  }
  else {
    // reply is ok, print response from server
    fprintf(stdout, "%s, (code %u)\n", reply_status->msg, (uint32_t)reply_status->err_code);
    return 1;
  }

  return 0;
}


static void display_nim_info(struct ntc_interfaces_s *ifs, int port_id) {
  char     tmpStr[128];

  printf("  Port type:       %s\n", translate_port_type(ifs->intf[port_id].nim_data.port_type));
  printf("  NIM ID:          %d (%s)\n",
         ifs->intf[port_id].nim_data.nimId, translate_nim_id(ifs->intf[port_id].nim_data.nimId));

  printf("  Vendor:          %s\n", ifs->intf[port_id].nim_data.vendorName);
  printf("  Product no:      %s\n", ifs->intf[port_id].nim_data.prodNo);
  printf("  Serial no:       %s\n", ifs->intf[port_id].nim_data.serialNo);
  printf("  Date:            %s\n", ifs->intf[port_id].nim_data.date);
  printf("  Revision:        %s\n", ifs->intf[port_id].nim_data.rev);

  if (ifs->intf[port_id].nim_data.pwrLevelReq > 1)
    printf("  Power level:     Required: %d, Current: %d\n", ifs->intf[port_id].nim_data.pwrLevelReq, ifs->intf[port_id].nim_data.pwrLevelCur);
  else
  {
    printf("  Power level:     ");

    if (ifs->intf[port_id].nim_data.pwrLevelReq > 0)
      printf("%i\n", ifs->intf[port_id].nim_data.pwrLevelReq);
    else
      printf("NA\n");
  }

  if (ifs->intf[port_id].nim_data.link_length.sm ||
      ifs->intf[port_id].nim_data.link_length.ebw ||
      ifs->intf[port_id].nim_data.link_length.mm50 ||
      ifs->intf[port_id].nim_data.link_length.mm62 ||
      ifs->intf[port_id].nim_data.link_length.copper) {
    bool addComma = false;
    printf("  Link length:     ");

    if (ifs->intf[port_id].nim_data.link_length.sm) {
      if (ifs->intf[port_id].nim_data.link_length.sm == 0xFFFF)
        snprintf(tmpStr, sizeof(tmpStr), ">= %d", 0xFFFF);
      else
        snprintf(tmpStr, sizeof(tmpStr), "%d", ifs->intf[port_id].nim_data.link_length.sm);

      printf("SM(9um): %sm", tmpStr);
      addComma = true;
    }

    if (ifs->intf[port_id].nim_data.link_length.ebw) {
      if (addComma)
        printf(", ");

      printf("EBW(50um): %im", ifs->intf[port_id].nim_data.link_length.ebw);
      addComma = true;
    }

    if (ifs->intf[port_id].nim_data.link_length.mm50) {
      if (addComma)
        printf(", ");

      printf("MM(50um): %im",ifs->intf[port_id].nim_data.link_length.mm50);
      addComma = true;
    }

    if (ifs->intf[port_id].nim_data.link_length.mm62) {
      if (addComma)
        printf(", ");

      printf("MM(62.5um): %im", ifs->intf[port_id].nim_data.link_length.mm62);
      addComma = true;
    }

    if (ifs->intf[port_id].nim_data.link_length.copper) {
      if (addComma)
        printf(", ");

      printf("CU: %im", ifs->intf[port_id].nim_data.link_length.copper);
    }

    printf("\n");
  }
  else
    printf("  Link length:     NotAvail\n");
}


static void print_port_state(struct ntc_interfaces_s *ifs, int port_id) {
  switch (ifs->intf[port_id].port_state)
  {
    case PORT_STATE_DISABLED:
      fprintf(stdout, "PORT_STATE_DISABLED\n");
      break;
    case PORT_STATE_NIM_PRESENT:
      fprintf(stdout, "PORT_STATE_NIM_PRESENT\n");
      break;
    case PORT_STATE_NIM_ABSENT:
      fprintf(stdout, "PORT_STATE_NIM_ABSENT\n");
      break;
    case PORT_STATE_VIRTUAL_UNATTACHED:
      fprintf(stdout, "PORT_STATE_VIRTUAL_UNATTACHED\n");
      break;
    case PORT_STATE_VIRTUAL_SPLIT:
      fprintf(stdout, "PORT_STATE_VIRTUAL_SPLIT\n");
      break;
    case PORT_STATE_VIRTUAL_PACKED:
      fprintf(stdout, "PORT_STATE_VIRTUAL_PACKED\n");
      break;
    case PORT_STATE_VIRTUAL_RELAY:
      fprintf(stdout, "PORT_STATE_VIRTUAL_RELAY\n");
      break;
  }
}


int main(int argc, const char **argv)
{
  struct cfg_data_s config;
  int len;
  uint8_t *data;
  uint64_t version;
  struct argparse argparse;

  memset(&config, 0, sizeof(config));

  int fd = ntconn_client_connect();

  if (fd < 0) {
    fprintf(stderr, "ERROR while connecting to %s\n", NTCONNECT_SOCKET);
    perror(NULL);
    return 0;
  }

  /*
   * Get version of NtConnect server
   */
  version = ntconn_client_get_version(fd, "0000:00:00.0", "server");
  if (version != 1ULL) {
    fprintf(stderr, "Server version %u.%u not supported\n", VERSION_HI(version), VERSION_LO(version));
    goto exit;
  }

  /*
   * Get all physical adapters and their PCI IDs
   */
  len = ntconn_client_request(fd, "0000:00:00.0", "server", "get,nic_pci_ids", &data, NULL);
  if (len > 0) {
    config.nics = (struct ntc_nic_pci_ids_s *)data;
  } else {
    fprintf(stderr, "No modules registered on server\n");
    goto exit;
  }

  if (config.nics->num_nics <= 0) {
    fprintf(stderr, "No SmartNICs found\n");
    goto exit;
  }


  argparse_init(&argparse, options, usages, 0);
  argparse_describe(&argparse, "\nCommand description:", usageExamples);
  argparse_parse(&argparse, argc, argv);

  config.adap_sel = adapter;
  if (config.adap_sel >= config.nics->num_nics) {
    fprintf(stderr, "Adapter %i not found\n", config.adap_sel);
    goto exit;
  }

  /*
   * Get version of the NtConnect adapter module
   */
  version = ntconn_client_get_version(fd, config.nics->nic_pci_id[config.adap_sel], "adapter");
  if (version != 1ULL) {
    fprintf(stderr, "Server version %u.%u not supported\n", VERSION_HI(version), VERSION_LO(version));
    goto exit;
  }

  /*
   * Get adapter info structure
   */
  len = ntconn_client_request(fd, config.nics->nic_pci_id[config.adap_sel], "adapter", "get,info", &data, NULL);
  if (len > 0) {
    config.info = (struct ntc_adap_get_info_s *)data;
  } else {
    fprintf(stderr, "Getting adapter info failed\n");
    goto exit;
  }

  /*
   * Get all interfaces configured on this adapter
   */
  len = ntconn_client_request(fd, config.nics->nic_pci_id[config.adap_sel], "adapter", "get,interfaces", &data, NULL);
  if (len > 0) {
    config.ifs = (struct ntc_interfaces_s *)data;
  } else {
    fprintf(stderr, "No interfaces found\n");
    goto exit;
  }


  /*
   * Ready to execute argument
   *
   * Implemented -s (set) commands:
   * config -a 0 -s port0,enable
   * config -a 0 -s port0,disable
   * config -a 0 -s port1,link_state=up
   * config -a 0 -s port1,link_state=down
   * config -a 0 -s port0,link_speed=25G
   *
   *
   * Implemented -g (get) commands:
   * config -g port1,link_speed
   * config -g port1,link_state
   *
   */
  if (set_opt) {
    char cmd[PARAM_SIZE + 32];
    struct reply_err_s reply_status = {0};
    // Set
    if (memcmp(set_opt, "port", 4) == 0) {
      snprintf(cmd, PARAM_SIZE + 32, "set,interface,%s", set_opt);
      len = ntconn_client_request(fd, config.nics->nic_pci_id[config.adap_sel], "adapter", cmd, &data, &reply_status);
      if (!parse_server_reply(len, data, &reply_status)) {
        goto exit;
      }
    } else
    if (memcmp(set_opt, "adapter", 7) == 0) {
      snprintf(cmd, PARAM_SIZE + 32, "set,adapter,%s", set_opt);
      len = ntconn_client_request(fd, config.nics->nic_pci_id[config.adap_sel], "adapter", cmd, &data, NULL);
      if (len) {
        printf("Error setting adapter parameter\n");
        goto exit;
      }
    }
  } else if (get_opt) {
    // Get
    if (memcmp(get_opt, "port", 4) == 0) {
      char *tok = strtok(get_opt, ",");
      if (!tok || strlen(tok) <= 4) {
        fprintf(stderr, "Wrong port params specified\n");
        goto exit;
      }
      int port_nr = strtol(tok + 4, NULL, 10);
      if (port_nr >= config.ifs->nb_ports) {
        fprintf(stderr, "Wrong port number specified\n");
        goto exit;
      }
      tok = strtok(NULL, ",");
      if (!tok) {
        fprintf(stderr, "Wrong port params specified\n");
        goto exit;
      }
      if (strcmp(tok, "link_speed") == 0) {
        fprintf(stdout, "%i\n", link_speed(config.ifs->intf[port_nr].port_speed));
      }
      else if (strcmp(tok, "link_state") == 0) {
        switch (config.ifs->intf[port_nr].link)
        {
          case PORT_LINK_UNKNOWN:
            fprintf(stdout, "Link state is unknown\n");
            break;
          case PORT_LINK_UP:
            fprintf(stdout, "Link state is up\n");
            break;
          case PORT_LINK_DOWN:
            fprintf(stdout, "Link state is down\n");
            break;
        }
      }
      else if (strcmp(tok, "nim") == 0) {
        display_nim_info(config.ifs, port_nr);
      }
      else if (strcmp(tok, "port_state") == 0) {
        print_port_state(config.ifs, port_nr);
      }
    }
  }


exit:
  close(fd);

  if (config.nics) {
    free(config.nics);
  }
  if (config.info) {
    free(config.info);
  }
  if (config.ifs) {
    free(config.ifs);
  }

  return 0;
}
