#ifndef _MONITORING_H_
#define _MONITORING_H_

#include "ntconn_client.h"
#include "ntconnect_api_adapter.h"
#include "ntconnect_api_statistic.h"

struct mon_data_s {
  uint64_t server_version;
  uint64_t mod_stat_version;
  uint64_t mod_adap_version;

  struct ntc_nic_pci_ids_s *nics;
  int sel;

  struct ntc_adap_get_info_s *info;
  struct ntc_interfaces_s *ifs;

  int stat_layout_version;
  struct ntc_stat_get_data_s *clr;
  struct ntc_stat_get_data_s *que;
  struct ntc_stat_get_data_s *rxc;
  struct ntc_stat_get_data_s *txc;
  struct ntc_stat_get_data_s *flm;

  struct ntc_stat_get_data_s *last_que;
  struct ntc_stat_get_data_s *last_rxc;
  struct ntc_stat_get_data_s *last_txc;
};

/*
 * Initialization of the main window and subwindows.
 * First data display.
*/
void init_display(struct mon_data_s *mon_data);

/*
 * Handle the data update on the screen and user input.
*/
void display(int failed);

/*
 * Full destroy of windows and terminal clearing.
*/
void deinit_display(void);


#endif // _MONITORING_H_
