#ifndef _UTILS_H_
#define _UTILS_H_

#include <stddef.h>
#include <stdint.h>

#define _unused __attribute__((__unused__))

#define INTERNAL_ERROR     -1
#define TRYAGAIN           -2
#define INVALID_PARAMETER  -3
#define CONNECTION_CLOSED  -4
#define CONNECTION_INVALID -5
#define TIMEOUT            -6

/*
 * Returns file descriptor on success
 */
int unix_connect(const char *path);

/*
 * Returns 0 on success. means message has been read into data buffer
 * less than 0 on error
 */
int read_data(int fd, size_t len, uint8_t *data, size_t *recv_len, int timeout);

/*
 * Returns 0 on success. means all requested data has been read into data buffer
 */
int read_all(int clfd, uint8_t *data, size_t length);

/*
 * Returns 0 on success. means all data of size in data buffer has been written to fd
 * -1 or error
 */
int write_all(int fd, const uint8_t *data, size_t size);

#endif // _UTILS_H_
